Option Explicit
On Error Resume Next 'This needs to be set or else the script will exit upon the first empty .Get()

Dim Action
Dim objAdr
Dim hWnd
Dim objMeedioClient

Const WM_USER = &H400

Set objAdr          = CreateObject("WSHExtend.WinExt")
hWnd                = objAdr.WSHFindWindow("meedio essentials")
Set objAdr          = Nothing
Set objMeedioClient = CreateObject("MeedioClient.MeedioPluginClient")

If objMeedioClient.Connect("localhost", 7500, "", hWnd, WM_USER + 10) Then
	Sleep 100
	objMeedioClient.AddSubjectMask("*")

	While GetMessage(objMeedioClient) = True
		Action = GetPropertyValue ("Music.Action Message")
		If Action <> "Waiting" Then
			SetpropertyValue "Music.Action Message", "Waiting"
			Select Case Action
				Case "Show_NowPlaying": Call SendMessage(objMeedioClient, "music.send-state")
			End Select
		End If
		Sleep 50
	Wend
	
	Sleep 100
	objMeedioClient.Flush
End If

Set objMeedioClient = Nothing


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub SendMessage(objMeedioClient, Message)
Dim objMessage

	Set objMessage = objMeedioClient.NewMessage(Message)
	objMessage.Send
	Set objMessage = Nothing
	Sleep 100
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function GetMessage(objMeedioClient)
Dim objMessage
Dim objList
Dim nit

	GetMessage     = True
	Set objMessage = objMeedioClient.GetNextMessage()
	
	Select Case objMessage.Subject
		Case "music.event.queue-changed":
			'ItemCount below can be used to refresh the complete queue at once
			'Right now, the queue is kept alive be adding or deleting only the newest queue line
			'ItemCount = objMessage.Get("count", "") '-> ItemCount needs to be Global because it must not reset when this Sub is executed after the Message.Send
			Call SendMessage(objMeedioClient, "music.send-queue")
		
		Case "music.event.current-item-changed":
			Call WaitForAction()
			SetPropertyValue "Music.Action", "NowPlaying^" & objMessage.Get("id", "") & "^" & objMessage.Get("section", "")

		Case "music.event.play-state-changed":
			Call WaitForAction()
			SetPropertyValue "Music.Action", "PlayState^" & objMessage.Get("play-state", "") & "^" & objMessage.Get("shuffle", "") & "^" & objMessage.Get("loop", "")
		
		Case "music.queue-file":
			Call WaitForAction()
			SetPropertyValue "Music.Action", "QueueAdd^" & objMessage.Get("id", "") & "^" & objMessage.Get("section", "")
		
		Case "music.add-to-queue":
			Call WaitForAction()
			Set objList = objMessage.List.Items(0)
			SetPropertyValue "Music.Action", "QueueAdd^" & objList.Get("id", "") & "^" & objList.Get("section", "")
			Set objList = Nothing

		Case "music.remove-from-queue":
			Call WaitForAction()
			SetPropertyValue "Music.Action", "QueueRemove^" & objMessage.Get("id", "") & "^" & objMessage.Get("section", "")
		
		Case "datafeed.publish"
			If objMessage.SourceName = "Music Player" Then
				If GetPropertyValue("Music.NowPlaying") = "Now Playing" Then
					SetPropertyValue "Music.Length", objMessage.Get("caption", "")
				End If
			End If 
		
		Case "plugin.closing":
			Sleep 5000 'Wait 5 seconds for Meedio to shut down so no more connections can be made
			SetPropertyValue "Music.Action", "Control^Stop" 'This forces a connect with Meedio which will fail and clear the playlist
			SetPropertyValue "Music.NowPlaying", ""
			GetMessage = False
	End Select
	
	Set objMessage = Nothing
End Function


'-------------------------------------------------------
'- Wait until Music.vbs has reset the Action property to
'- 'Waiting' before setting the Action property again to
'- avoid skipped actions
'-------------------------------------------------------
Sub WaitForAction()

	While GetPropertyValue("Music.Action") <> "Waiting"
		Sleep 50
	Wend
End Sub