'Rip Meedio Music SQLite database

'ToDo
' Indicators in buttons verwerken
' Queue remove item maken in HouseBot
' Playlist alphalist cappen op 9800 Bytes


Option Explicit
'On Error Resume Next

Dim Action
Dim objDB
Dim Status
Dim DataBase
Dim SelectedID
Dim SelectedArtist
Dim SelectedAlbum
Dim SelectedCover
Dim EmptyQueue
Dim CurrentPlayState	'Used to prevent recursive randomplay loops
Dim RandomPlayFlag	'Flag used to switch on Random Play (single play) mode
Dim NextLevelFlag       'Flag used in Set_NextLevel and Process_Key. Set True in Set_NextLevel for proper indexing
Dim MusicIndex
Dim MusicCount		'MusicCount contains the max hits of a selection -> Used for stepping through to end of index
Dim LastSelectedKey	'Used for buffering selected key when stepping through the index
Dim SQL_Selection	'Used for building a Genre and / or Decade SQL query
Dim strType		'Artist, Album, Song
Dim strGenre
Dim strDecade
Dim tagType		'The tag that goes with strType
Dim tagArtist
Dim tagAlbum
Dim tagGenre
Dim tagDecade
Dim tagBand
Dim tagTrack
Dim tagLength
Dim tagYear
Dim tagPublisher
Dim tagComposer
Dim arrDataBase

                    'Action^    DBase Filename        Panel Title -> Action is set, the rest may vary according own names
arrDataBase = Array("Jukebox", "Music.mlf",          "Jukebox", _
		    "Top2000", "Music Top 2000.mlf", "Top 2000")

Const MaxListItems    = 100
Const MaxQueuedTracks = 30


'-------------------------------------------------------
'- Main ------------------------------------------------
'-------------------------------------------------------
Set objDB      = CreateObject("newObjects.sqlite.dbutf8")
objDB.AutoType = True
Status         = ""
CurrentPlayState = "stop"
RandomPlayFlag = "Off"
NextLevelFlag  = False
MusicIndex     = 0
SelectedID     = -1
SelectedArtist = ""
SelectedAlbum  = ""
SelectedCover  = ""
strType        = "Song"
strGenre       = "All"
strDecade      = "All"
SQL_Selection  = ""
EmptyQueue     = ">> Geen tracks in de queue"
DataBase       = arrDataBase(1)

SetPropertyValue "Get Meedio Messages.State", "Stopped" 'This clears all messages in case the music script restarts while playing
SetPropertyValue "Music.Random", RandomPlayFlag
Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & DataBase)
Call Set_Type("Song")
Call Set_Tags(objDB)
objDB.Close

Randomize

Do
	Sleep 1
	Action = GetPropertyValue ("Music.Action")
	If Action <> "Waiting" Then
		SetpropertyValue "Music.Action", "Waiting"
		If Action <> "" Then
			Call Handle_MusicAction(objDB, Action)
			If Err.Number <> 0 Then
				Status = "Error: " & Err.Description
				Err.Clear
			End If
			SetPropertyValue "Music.Status", Status
			Status = ""
		End If
		'Keep this Action = Waiting here so Waiting is set AFTER the command is finished
		'The GetMeedioMessage script waits for Waiting before sending the next input
'		Action = "Waiting"
		Sleep 50
	End If
Loop

Set objDB = Nothing


'-------------------------------------------------------
'- Handle Actions --------------------------------------
'-------------------------------------------------------
Sub Handle_MusicAction(objDB, Action)
Dim objRow
Dim Data

	Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & DataBase)
	Data = Split(Action, "^") 'No Underscore because many filenames use underscores!

	Select Case Data(0)
		Case "Refresh"    : Call Refresh_Panel(objDB)
		Case "DataBase"   : Call Set_DataBase(objDB, Data(1), Data(2))
		Case "Type"       : Call Set_Type(Data(1))
		Case "GenreName"  : Call Set_Genre(Data(1))
		Case "Decade"     : Call Set_Decade(Data(1))
		Case "Index"      : Call Set_Index(objDB, Data(1))
		Case "Select"     : MusicIndex = 0 : Call Set_NextLevel(objDB) 'Selects Albums from Artist or Songs from Albums
		Case "SendKey"    : MusicIndex = 0 : Call Process_Key(objDB, Data(1))
		Case "MusicName"  : Call Get_MusicData(objDB, Data(1), False) 'Data(1) = item_id, Data(2) = item_name, Flag = Show Now Playing - True, False
		Case "Queue"      : Call Set_Queue(objDB)
		Case "QueueAdd"   : Call Queue_Add(objDB, Data(1), Data(2)) 'Data(1) = item_id, Data(2) = section (library name)
		Case "QueueRemove": Call Queue_Remove(objDB, Data(1), Data(2)) 'Data(1) = item_id, Data(2) = section (library name)
		Case "QueueRandom": Call Handle_Random(objDB, "Queue", Data(1)) 'Data(1) = Amount of random tracks to put on the queue
		Case "Control"    : Call HandleMusicControls(objDB, Data(1), SelectedID) 'Play, Stop, Pause
		Case "NowPlaying" : Call Show_NowPlaying(objDB, Data(1), Data(2)) 'Data(1) = item_id, Data(2) = section (library name)
		Case "RandomPlay" : Call Set_RandomPlay(objDB)
		Case "PlayState"  : Call Handle_PlayState(Data(1), Data(2), Data(3)) 'Data(1) = Play-State, Data(2) = Shuffle, Data(3) = Repeat -> True or False (String)
	End Select

	objDB.Close
End Sub


'-------------------------------------------------------
'- Refresh Panel ---------------------------------------
'-------------------------------------------------------
Sub Refresh_Panel(objDB)
Dim objRow
Dim arrGenre()
Dim GenreList
Dim arrDecade
Dim nit

arrDecade = Array("1970", "1980", "1990", "2000")
	
	Call Set_Tags(objDB)
	SetPropertyValue "Music.Artist Count", 0
	SetPropertyValue "Music.Album Count", 0
	SetPropertyValue "Music.Song Count", 0
	SetPropertyValue "Music.Decade Count 1970", 0
	SetPropertyValue "Music.Decade Count 1980", 0
	SetPropertyValue "Music.Decade Count 1990", 0
	SetPropertyValue "Music.Decade Count 2000", 0
	
	
	If tagArtist <> "--" Then
		Set objRow = objDB.Execute("SELECT DISTINCT " & tagArtist & " FROM items")
		SetPropertyValue "Music.Artist Count", objRow.Count
		Set objRow = Nothing
	Else
		SetPropertyValue "Music.Artist Count", 0
	End If
	
	If tagAlbum <> "--" Then
		Set objRow = objDB.Execute("SELECT item_image, " & tagAlbum & _
					   " FROM items WHERE " & tagType & " LIKE '%' " & _
					   " GROUP BY " & tagAlbum & ", item_image")
		SetPropertyValue "Music.Album Count", objRow.Count
		Set objRow = Nothing
	Else
		SetPropertyValue "Music.Album Count", 0
	End If
	
	Set objRow = objDB.Execute("SELECT item_name FROM items WHERE item_name LIKE '%'")
	SetPropertyValue "Music.Song Count", objRow.Count
	Set objRow = Nothing
	
	If tagDecade <> "--" Then
		For nit = 0 To UBound(arrDecade)
			Set objRow = objDB.Execute("SELECT * FROM items WHERE " & tagDecade & " LIKE '" & arrDecade(nit) & "'")
			SetPropertyValue "Music.Decade Count " & arrDecade(nit), objRow.Count
			Set objRow = Nothing
		Next
	Else
		For nit = 0 To UBound(arrDecade)
			SetPropertyValue "Music.Decade Count " & arrDecade(nit), 0
		Next
	End If
		
	If tagGenre <> "--" Then
		Set objRow = objDB.Execute("SELECT DISTINCT " & tagGenre & " FROM items ORDER BY " & tagGenre)
		ReDim arrGenre(objRow.Count)
		
		For nit = 1 To objRow.Count
			arrGenre(nit) = objRow(nit)(tagGenre)
		Next
	
		GenreList = "*S-" & "GenreName^All" & vbTAB & vbTAB & "All"

		For nit = 1 to UBound(arrGenre)
			Set objRow = objDB.Execute("SELECT item_id FROM items WHERE " & tagGenre & " LIKE '" & Replace(arrGenre(nit), "'", "_") & "'")
			GenreList  = GenreList & vbLF & "GenreName^" & arrGenre(nit) & vbTAB & objRow.Count & vbTAB & arrGenre(nit)
			Set objRow = Nothing
			SetPropertyValue "Music.Genre List", GenreList
		Next
	Else
		SetPropertyValue "Music.Genre List", " "
	End If
	
	Call Set_Type("Song")
	Call Set_Genre("All")
	Call Set_Decade("All")
	Call Process_Key(objDB, "All")
End Sub


'-------------------------------------------------------
'- Select the database ---------------------------------
'-------------------------------------------------------
Sub Set_DataBase(objDB, Data, RefreshFlag)
Dim nit
Dim OldDataBase
Dim strDBaseTitle

	If RefreshFlag = "Yes" Then
		DataBase = "" 'Change DataBase so a Refresh Call will be forced
	End If
	
	OldDataBase   = DataBase 'If a database is selected which is already selected -> don't do anything
	DataBase      = arrDataBase(1)
	strDBaseTitle = arrDataBase(2)

	For nit = 0 To UBound(arrDataBase) step 3
		If Data = arrDataBase(nit) Then
			DataBase      = arrDataBase(nit + 1)
			strDBaseTitle = arrDataBase(nit + 2)
		End If			
	Next

	OpenRemotePanel("M_HB_Muziek")

	If OldDataBase <> DataBase Then
		SetPropertyValue "Music.DataBase", strDBaseTitle
		objDB.Close 'This needs to be here because a Call is made which opens the new database
		Call Handle_MusicAction(objDB, "Refresh")
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_Type(Data)

	Select Case Data:
		Case "Artist": tagType = tagArtist
		Case "Album" : tagType = tagAlbum
		Case "Song"  : tagType = "item_name"
	End Select
	
	strType = Data
	SetPropertyValue "Music.Type", Data
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_Genre(Data)

	strGenre = Replace(Data, "'", "_")
	Call Set_SQLSelection()
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_Decade(Data)

	If tagDecade <> "--" Then
		strDecade = Replace(Data, "'", "_")
	Else
		strDecade = "All"
	End If

	Call Set_SQLSelection()
	SetPropertyValue "Music.Decade", strDecade

End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_Index(objDB, Data)

	Select Case Data
		Case "Start":
			MusicIndex = 0
			
		Case "End":
			If MusicCount - MaxListItems > 0 Then
				MusicIndex = MusicCount - MaxListItems
			End If
			
		Case "Prev":
			If MusicIndex - MaxListItems < 0 Then
				MusicIndex = 0
			Else
				MusicIndex = MusicIndex - MaxListItems
			End If
			
		Case "Next":
			If MusicIndex + MaxListItems < MusicCount Then
				MusicIndex = MusicIndex + MaxListItems
			End If
	End Select
	
	'SQL Selections while indexing are different for both subs below.
	If NextLevelFlag = True Then
		Call Index_NextLevel(objDB)
	Else
		Call Process_Key(objDB, LastSelectedKey)
	End If
End Sub


'-------------------------------------------------------
'- Theme Select Button. Gets Albums form Artist or Songs from Album
'-------------------------------------------------------
Sub Set_NextLevel(objDB)
Dim objRow

	NextLevelFlag = True
	
	Select Case strType
		Case "Artist":
			If SelectedArtist <> "" Then
				Set objRow = objDB.Execute("SELECT item_id, " & tagAlbum & _
							   " FROM items WHERE " & tagArtist & _
							   " LIKE '" & SelectedArtist & "'" & _
							   " GROUP BY " & tagAlbum & _
							   " ORDER BY " & tagAlbum & " ASC")
				MusicCount = objRow.Count
				Call Set_Type("Album")
				Call Fill_NameList(objDB, objRow)
				Set objRow = Nothing
			Else
				Status = "No name selected"
			End If

		Case "Album":
			If SelectedAlbum <> "" Then
				Set objRow = objDB.Execute("SELECT item_id FROM items WHERE item_image LIKE '" & SelectedCover & _
							   "' AND " & tagAlbum & " LIKE '" & SelectedAlbum & "'")
				MusicCount = objRow.Count
				Set objRow = Nothing
				
				Set objRow = objDB.Execute("SELECT item_id, item_name FROM items WHERE item_image LIKE '" & SelectedCover & _
							   "' AND " & tagAlbum & " LIKE '" & SelectedAlbum & _
							   "' ORDER BY ABS(" & tagTrack & ") ASC" & _
							   " LIMIT " & MusicIndex & ", " & MaxListItems)
				Call Set_Type("Song")
				Call Fill_NameList(objDB, objRow)
				Set objRow = Nothing
			Else
				Status = "No name selected"
			End If
	End Select
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Process_Key(objDB, Data)
Dim objRow
Dim ItemSelection
Dim KeySelection

	NextLevelFlag = False
	KeySelection  = ""
	
	If Data <> "All" Then
		KeySelection = " LIKE " & "'" & Data & "%'"
	Else
		KeySelection = " LIKE " & "'%'"
	End If
	
	Select Case strType
		Case "Artist":
			Set objRow = objDB.Execute("SELECT DISTINCT " & tagType & " FROM items WHERE " & SQL_Selection & tagType & KeySelection )
			MusicCount = objRow.Count
			Set objRow = Nothing
		
			Set objRow = objDB.Execute("SELECT item_id, " & tagType & " FROM items WHERE " & SQL_Selection & tagType & KeySelection & _
						   " GROUP BY " & tagType & _
						   " ORDER BY " & tagType & " ASC" & _
						   " LIMIT " & MusicIndex & ", " & MaxListItems)
			If Fill_NameList(objDB, objRow) = True Then
				Call Get_MusicData(objDB, objRow(1)("item_id"), False)
			End If
			Set objRow = Nothing

		Case "Album":
			Set objRow = objDB.Execute("SELECT item_id, item_image, " & tagAlbum & _
						   " FROM items WHERE " & SQL_Selection & tagType & KeySelection & _
						   " GROUP BY " & tagAlbum & ", item_image")
			MusicCount = objRow.Count
			Set objRow = Nothing

			Set objRow = objDB.Execute("SELECT item_id, item_image, " & tagAlbum & _
						   " FROM items WHERE " & SQL_Selection & tagType & KeySelection & _
						   " GROUP BY " & tagAlbum & ", item_image " & _
						   " ORDER BY " & tagType & " ASC" & _
						   " LIMIT " & MusicIndex & ", " & MaxListItems)
			If Fill_NameList(objDB, objRow) = True Then
				Call Get_MusicData(objDB, objRow(1)("item_id"), False)
			End If
			Set objRow = Nothing

		Case "Song":
			Set objRow = objDB.Execute("SELECT item_name FROM items WHERE " & SQL_Selection & tagType & KeySelection)
			MusicCount = objRow.Count
			Set objRow = Nothing
	
			Set objRow = objDB.Execute("SELECT item_id, item_name FROM items WHERE " & SQL_Selection & tagType & KeySelection & _
						   " ORDER BY " & tagType & " ASC" & _
						   " LIMIT " & MusicIndex & ", " & MaxListItems)
			If Fill_NameList(objDB, objRow) = True Then
				Call Get_MusicData(objDB, objRow(1)("item_id"), False)
			End If
			Set objRow = Nothing

	End Select

	LastSelectedKey = Data
End Sub


'-------------------------------------------------------
'- Display Music Data when an alphalist selection is made
'-------------------------------------------------------
Sub Get_MusicData(objDB, ItemID, NowPlayingFlag)
Dim objRow
Dim FileSystem
Dim ThumbnailName
Dim Length, Lengte

	SelectedArtist = ""
	SelectedAlbum  = ""
	Set objRow     = objDB.Execute("SELECT * FROM items WHERE item_id = '" & CStr(ItemID) & "'")

	If objRow.Count > 0 Then
		Select Case strType
			Case "Artist": SelectedArtist = Replace(objRow(1)(tagArtist), "'", "_")
			Case "Album" : SelectedArtist = Replace(objRow(1)(tagArtist), "'", "_")
				       SelectedAlbum  = Replace(objRow(1)(tagAlbum), "'", "_")
			Case "Song"  : SelectedAlbum  = Replace(objRow(1)(tagAlbum), "'", "_")
		End Select
		
		ThumbnailName = Get_Item(objRow, 1, "item_image")
		SelectedCover = Replace(ThumbnailName, "'", "_")
		SelectedID    = ItemID
		Length        = Get_Item(objRow, 1, tagLength)
		If Length <> "--" Then
			Length = (Length / 1000) \ 60 & ":" & L_Pad(((Length) / 1000) Mod 60, 2, "0")
		End If
		SetPropertyValue "Music.Length",    Length
		SetPropertyValue "Music.Artist",    Get_Item(objRow, 1, tagArtist)
		SetPropertyValue "Music.Band",      Get_Item(objRow, 1, tagBand)
		SetPropertyValue "Music.Album",     Get_Item(objRow, 1, tagAlbum)
		SetPropertyValue "Music.Song",      Get_Item(objRow, 1, tagTrack) & " - " & Get_Item(objRow, 1, "item_name")
		SetPropertyValue "Music.Genre",     Get_Item(objRow, 1, tagGenre)
		SetPropertyValue "Music.Year",      Get_Item(objRow, 1, tagYear)
		SetPropertyValue "Music.Publisher", Get_Item(objRow, 1, tagPublisher)
		SetPropertyValue "Music.Composer",  Get_Item(objRow, 1, tagComposer)
	End If

	Set FileSystem = CreateObject("Scripting.FileSystemObject")
	If FileSystem.FileExists(ThumbnailName) = False Or (LCase(Right(ThumbnailName, 3)) <> "jpg" And LCase(Right(ThumbnailName, 3)) <> "png") Then
		Status = Right(ThumbnailName, 20)
		ThumbnailName = "C:\Program Files\Meedio\Meedio HouseBot\Config\Themes\Meedio Autohome\Music\No Image.jpg"
	End If
	
	SetPropertyValue "Music.Thumbnail", ThumbnailName
	
	If NowPlayingFlag = True Then
		SetPropertyValue "Music.NowPlaying", "Now Playing"
	Else
		SetPropertyValue "Music.NowPlaying", ""
	End If

	Set FileSystem = Nothing
	Set objRow     = Nothing
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_Queue(objDB)
Dim objRow
Dim nit
Dim Total

	Select Case strType
		Case "Album":
			Set objRow = objDB.Execute("SELECT * FROM items WHERE item_image LIKE '" & SelectedCover & _
						   "' AND " & tagAlbum & " LIKE '" & SelectedAlbum & _
						   "' ORDER BY ABS(" & tagTrack & ") ASC")
		
			If objRow.Count > MaxQueuedTracks Then
				Total  = MaxQueuedTracks
				Status = "Track list capped at " & Total & " tracks!"
			Else
				Total = objRow.Count
			End If
			
			For nit = 1 To Total
				Call HandleMusicControls(objDB, "Queue", objRow(nit)("item_id"))
			Next
			
			Set objRow = Nothing
	 	
	 	Case "Song":
			Call HandleMusicControls(objDB, "Queue", SelectedID)
	End Select
End Sub


'-------------------------------------------------------
'- Called by GetMeedioMessage if a file is put on the queue
'-------------------------------------------------------
Sub Queue_Add(objDB, ItemID, Section)
Dim PlayList
Dim objRow
Dim TempDataBase
Dim TempSection

	TempDataBase = Split(DataBase, ".") 'Strip .mlf -> Meedio itself doesn't use .mlf, but this script does!
	TempSection  = Split(Section, ".")
	
	If TempSection(0) <> TempDataBase(0) Then
		objDB.close
		Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & TempSection(0) & ".mlf")
	End If

	Set objRow = objDB.Execute("SELECT item_id, item_name FROM items WHERE item_id = '" & ItemID & "'")

	PlayList = GetPropertyValue("Music.Play List")
	
	If Left(PlayList, 2) = ">>" Then
		PlayList = ""
	End If
	
	PlayList = PlayList & vbLF & "^" & ItemID & "^" & vbTAB & Get_Item(objRow, 1, "item_name")
	SetPropertyValue "Music.Play List", PlayList
	Set objRow = Nothing
	
	If TempDataBase(0) <> TempSection(0) Then
		objDB.Close
		Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & TempDataBase(0) & ".mlf")
	End If

End Sub


'-------------------------------------------------------
'- Called by GetMeedioMessage if a file is removed from the queue
'-------------------------------------------------------
Sub Queue_Remove(objDB, ItemID, Section)
Dim nit
Dim nic
Dim PLayList
Dim PlayListData
Dim PlayListLines

	PlayList      = ""
	PlayListData  = Split(GetPropertyValue("Music.Play List"), "^") '(0) = vbLF, (1) = ID, (2) = item_name
	PlayListLines = Split(GetPropertyValue("Music.Play List"), vbLF)

	For nit = 0 To UBound(PlayListLines) - 1
		If PlayListData(nit * 2 + 1) = ItemID Then
			For nic = 0 To UBound(PlayListLines) - 1
				If nic <> nit Then
					PlayList = PlayList & vbLF & PlayListLines(nic + 1)
				End If
			Next

			If PlayList = "" Then
				SetPropertyValue "Music.Play List", EmptyQueue
				SetPropertyValue "Music.NowPlaying", ""
			Else
				SetPropertyValue "Music.Play List", PlayList
			End If
			Exit For
		End If
	Next
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_Random(objDB, PlayType, ItemCount)
Dim objRow
Dim nit
Dim RandomItem
Dim MaxItems
	
	SetPropertyValue "Music.Random", RandomPlayFlag
	Set objRow = objDB.Execute("SELECT item_id FROM items WHERE " & SQL_Selection & "item_name LIKE '%'")
	MaxItems   = objRow.Count
	
	If MaxItems > 0 Then
		For nit = 1 To ItemCount
			RandomItem = Rnd * MaxItems
			If RandomItem = 0 Then 'Make sure objRow(0) does not occur
				RandomItem = MaxItems
			End If

			Call HandleMusicControls(objDB, PlayType, objRow(Round(RandomItem))("item_id"))
		Next
	End If
	
	Set objRow = Nothing
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub HandleMusicControls(objDB, Data, PlayMusicID)
Dim nit
Dim objRow
Dim objShell
Dim objMeedioClient
Dim objMessage
Dim ItemLocation
Dim FileName

	If GetPropertyValue("Get Meedio Messages.State") = "Stopped" Then
		SetPropertyValue "Get Meedio Messages.State", "Running"
		Sleep 200 'Let the GetMeedioMessage script settle so it doesn't miss the first message
	End If
	
	Set objMeedioClient = CreateObject("MeedioClient.MeedioPluginClient")

	If objMeedioClient.Connect("localhost" ,7500 ,"" ,0 ,0) Then
		Select Case Data
			Case "Play"     : RandomPlayFlag = "Off"
					  If PlayMusicID <> -1 Then
						Set objRow = objDB.Execute("SELECT * FROM items WHERE item_id = '" & PlayMusicID & "'")
				          	Call MusicControl(objMeedioClient, objRow, "music.play-file")
					  	SetPropertyValue "Music.Play List", vbLF & "^" & PlayMusicID & "^" & vbTAB & Get_Item(objRow, 1, "item_name")
					  	Set objRow = Nothing
					  Else
						SetPropertyValue "Music.Name List", "No item selected to play"
					  End If

			Case "Random"   : Set objRow = objDB.Execute("SELECT * FROM items WHERE item_id = '" & PlayMusicID & "'")
				          Call MusicControl(objMeedioClient, objRow, "music.play-file")
					  SetPropertyValue "Music.Play List", vbLF & "^" & PlayMusicID & "^" & vbTAB & Get_Item(objRow, 1, "item_name")
					  Set objRow = Nothing
					  
			Case "PlayQueue": RandomPlayFlag = "Off"
					  Call MusicControl(objMeedioClient, "", "music.stop")
				          Call MusicControl(objMeedioClient, "", "music.play")
       	
			Case "Pause"    : Call MusicControl(objMeedioClient, "", "music.pause")
			
			Case "Stop"     : RandomPlayFlag = "Off"
					  Call MusicControl(objMeedioClient, "", "music.stop")

			Case "Queue"    : RandomPlayFlag = "Off"
					  If PlayMusicID <> -1 Then
						Set objRow = objDB.Execute("SELECT * FROM items WHERE item_id = '" & PlayMusicID & "'")
						Call MusicControl(objMeedioClient, objRow, "music.queue-file")
					  	Set objRow = Nothing
					  Else
						SetPropertyValue "Music.Name List", "No item selected to queue"
					  End If

			Case "Clear"    : RandomPlayFlag = "Off"
					  Call MusicControl(objMeedioClient, "", "music.clear-queue")
					  SetPropertyValue "Music.Play List", EmptyQueue
					  SetPropertyValue "Music.NowPlaying", ""
       	
			Case "Rewind"   : Call MusicControl(objMeedioClient, "", "music.rewind")
			Case "Forward"  : Call MusicControl(objMeedioClient, "", "music.fast-forward")
			
			Case "Next"     : If RandomPlayFlag = "On" Then
						Call MusicControl(objMeedioClient, "", "music.stop")
					  Else
					  	Call MusicControl(objMeedioClient, "", "music.next")
					  End If
			
			Case "Prev"     : Call MusicControl(objMeedioClient, "", "music.previous")
			Case "Shuffle"  : Call MusicControl(objMeedioClient, "", "music.shuffle-toggle")
			Case "Repeat"   : Call MusicControl(objMeedioClient, "", "music.repeat-toggle")
		End Select
       	
		Sleep 100
		objMeedioClient.Flush
	Else
		SetPropertyValue "Music.Play List", ">> No connection with Meedio"
		RandomPlayFlag   = "Off"
		CurrentPlayState = "stop"
	End If

	SetPropertyValue "Music.Random", RandomPlayFlag
	Set objMeedioClient = Nothing
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Show_NowPlaying(objDB, ItemID, Section)
Dim TempSection  'Library value returned from a Meedio message
Dim TempDataBase 'Scripts global DataBase
Dim TempItemID   'Used to reset ItemID after Now Playing is set
Dim PlayListID   'Used to select the correct line in Play List
Dim PlayListLines
Dim PlayList
Dim nit
Dim nic
	
	PlayList     = ""
	TempDataBase = Split(DataBase, ".") 'Strip .mlf -> Meedio itself doesn't use .mlf, but this script does!
	TempSection  = Split(Section, ".")

	If IsNumeric(ItemID) = True Then
		If TempSection(0) <> TempDataBase(0) Then
			objDB.close
			Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & TempSection(0) & ".mlf")
		End If

		TempItemID    = SelectedID
		PlayListID    = Split(GetPropertyValue("Music.Play List"), "^")
		PlayListLines = Split(GetPropertyValue("Music.Play List"), vbLF)

		For nit = 0 To UBound(PlayListLines) - 1
			If PlayListID(nit * 2 + 1) = ItemID Then
				For nic = 0 To UBound(PlayListLines) - 1
					If nic = nit Then
						PlayList = PlayList & vbLF & "*S-" & Replace(PlayListLines(nic + 1), "*S-", "")
					Else
						PlayList = PlayList & vbLF & Replace(PlayListLines(nic + 1), "*S-", "")
					End If
				Next
				
				If Len(PlayList) < 9800 Then
					SetPropertyValue "Music.Play List", PlayList
				Else
					SetPropertyValue "Music.Play List", "Out of memory. Decrease Play List -> " & Len(PlayList)
				End If
				Exit For
			End If
		Next

		Call Get_MusicData(objDB, itemID, True)
		SelectedID = TempItemID
		
		If TempDataBase(0) <> TempSection(0) Then
			objDB.Close
			Call objDB.Open("C:\Program Files\Meedio\Meedio Essentials\library\" & TempDataBase(0) & ".mlf")
		End If
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_RandomPlay(objDB)

	If RandomPlayFlag = "Off" Then
		RandomPlayFlag = "On"
		If CurrentPlayState <> "play" Then
			Call Handle_Random(objDB, "Random", 1)
		End If
	Else
		RandomPlayFlag = "Off"
	End If
	
	SetPropertyValue "Music.Random", RandomPlayFlag
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_PlayState(PlayState, Shuffle, Repeat)

	If RandomPlayFlag = "On" And PlayState = "stop" Then
		Call Handle_Random(objDB, "Random", 1)
	End If

	CurrentPlayState = PlayState

	Select Case Shuffle
		Case "True"  : SetPropertyValue "Music.Shuffle", "On"
		Case "False" : SetPropertyValue "Music.Shuffle", "Off"
		Case Else    : Status = "Shuffle = Unknown"
	End Select
	
	Select Case Repeat
		Case "True"  : SetPropertyValue "Music.Repeat", "On"
		Case "False" : SetPropertyValue "Music.Repeat", "Off"
		Case Else    : Status = "Repeat = Unknown"
	End Select
End Sub


'-------------------------------------------------------
'- Commonly used Subs and Functions --------------------
'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub MusicControl(objMeedioClient, objRow, strCommand)
Dim objMessage

	Set objMessage = objMeedioClient.NewMessage(strCommand)
	
	If objRow <> "" Then
		objMessage("album")       = Get_Item(objRow, 1, tagAlbum)
		objMessage("artist")      = Get_Item(objRow, 1, tagArtist)
		objMessage("band")        = Get_Item(objRow, 1, tagBand)
		objMessage("decade")      = Get_Item(objRow, 1, tagDecade)
		objMessage("genre")       = Get_Item(objRow, 1, tagGenre)
		objMessage("length")      = Get_Item(objRow, 1, tagLength)
		objMessage("publisher")   = Get_Item(objRow, 1, tagPublisher)
		objMessage("track")       = Get_Item(objRow, 1, tagTrack)
		objMessage("year")        = Get_Item(objRow, 1, tagYear)
		objMessage("name")        = Get_Item(objRow, 1, "item_name")
		objMessage("section")     = DataBase
		objMessage("external-id") = Get_Item(objRow, 1, "item_ext_id")
		objMessage("id")          = Get_Item(objRow, 1, "item_id")
		objMessage("file")        = Get_Item(objRow, 1, "item_location")
		objMessage("caption")     = Get_Item(objRow, 1, "item_name")
		'objMessage("image")      = Get_Item(objRow, 1, "item_image")
		objMessage("composer")    = Get_Item(objRow, 1, tagComposer)
	End If
	
	objMessage.Send
	Set objMessage = Nothing
	Sleep 400
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function Fill_NameList(objDB, objRow)
Dim objTempRow
Dim Row
Dim MusicList

	SelectedArtist = ""
	SelectedAlbum  = ""
	Fill_NameList  = True

	If objRow.Count > 0 Then
		'Get all data so previous SQL queries done in Index_NextLevel etc don't have to get Artist, Album and Cover data
		Set objTempRow = objDB.Execute("SELECT * FROM items WHERE item_id = '" & objRow(1)("Item_id") & "'") 
		
		If IsNull(objRow(1)(tagType)) = False Then
			MusicList     = "*S-" & "MusicName^" & objRow(1)("item_id") & vbTAB & objRow(1)(tagType)
			SelectedCover = Replace(Get_Item(objTempRow, 1, "item_image"), "'", "_")

			Select Case strType 'Auto Select first item in a new list
				Case "Artist": SelectedArtist = Replace(objTempRow(1)(tagArtist), "'", "_")
				Case "Album" : SelectedArtist = Replace(objTempRow(1)(tagArtist), "'", "_")
					       SelectedAlbum  = Replace(objTempRow(1)(tagAlbum), "'", "_")
				Case "Song"  : SelectedAlbum  = Replace(objTempRow(1)(tagAlbum), "'", "_")
			End Select
		
		Set objTempRow = Nothing
		End If
		
		For Row = 2 to objRow.Count
			If IsNull(objRow(Row)(tagType)) = False Then
				MusicList = MusicList & vbLF & "MusicName^" & objRow(Row)("item_id") & vbTAB & objRow(Row)(tagType)
			End If
		Next
		
		If MusicCount < (MusicIndex + MaxListItems) Then
			SetPropertyValue "Music.Index", MusicIndex + 1 & " - " & MusicCount & " : " & MusicCount
		Else
			SetPropertyValue "Music.Index", MusicIndex + 1 & " - " & MusicIndex + MaxListItems & " : " & MusicCount
		End If

		If Len(MusicList) < 9800 Then
			SetPropertyValue "Music.Name List", MusicList
		Else
			SetPropertyValue "Music.Name List", "Out of memory. Decrease MaxItemList -> " & Len(MusicList)
		End If
	Else
		SetPropertyValue "Music.Name List", "No items for this selection"
		SelectedID    = -1
		Fill_NameList = False
	End If
End Function


'-------------------------------------------------------
'- Called from Set_Index to index properly after selecting Artist Albums or Album Songs
'-------------------------------------------------------
Sub Index_NextLevel(objDB)
Dim objRow

	NextLevelFlag = True
	
	Select Case strType
		Case "Album":
			If SelectedArtist <> "" Then
				Set objRow = objDB.Execute("SELECT item_id, " & tagAlbum & _
							   " FROM items WHERE " & tagArtist & _
							   " LIKE '" & SelectedArtist & "'" & _
							   " GROUP BY " & tagAlbum & _
							   " ORDER BY " & tagAlbum & " ASC")
				Call Fill_NameList(objDB, objRow)
				Set objRow = Nothing
			Else
				SelectedID = -1
				SetPropertyValue "Music.Name List", "No items for this selection"
			End If

		Case "Song":
			If SelectedAlbum <> "" Then
				Set objRow = objDB.Execute("SELECT item_id, item_name FROM items WHERE item_image LIKE '" & SelectedCover & _
							   "' AND " & tagAlbum & " LIKE '" & SelectedAlbum & _
							   "' ORDER BY ABS(" & tagTrack & ") ASC" & _
							   " LIMIT " & MusicIndex & ", " & MaxListItems)
				Call Fill_NameList(objDB, objRow)
				Set objRow = Nothing
			Else
				SelectedID = -1
				SetPropertyValue "Music.Name List", "No items for this selection"
			End If
	End Select
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Set_SQLSelection()
	If strGenre <> "All" Then
		If strDecade <> "All" Then
			SQL_Selection = tagGenre & " LIKE '" & strGenre & "' AND " & tagDecade & " LIKE '" & strDecade & "' AND "
		Else
			SQL_Selection = tagGenre & " LIKE '" & strGenre & "' AND "
		End If
	Else
		If strDecade <> "All" Then
			SQL_Selection = tagDecade & " LIKE '" & strDecade & "' AND "
		Else
			SQL_Selection = ""
		End If
	End If
End Sub


'-------------------------------------------------------
'- Set all Tag names -> Global variables ---------------
'-------------------------------------------------------
Sub Set_Tags(objDB)
	
	tagArtist    = Get_Tag(objDB, "Artist")
	tagAlbum     = Get_Tag(objDB, "Album")
	tagGenre     = Get_Tag(objDB, "Genre")
	tagDecade    = Get_Tag(objDB, "Decade")
	tagBand      = Get_Tag(objDB, "Band")
	tagTrack     = Get_Tag(objDB, "Track")
	tagLength    = Get_Tag(objDB, "Length")
	tagYear      = Get_Tag(objDB, "Year")
	tagPublisher = Get_Tag(objDB, "Publisher")
	tagComposer  = Get_Tag(objDB, "Composer")
End Sub


'-------------------------------------------------------
'- Get a tagName ---------------------------------------
'-------------------------------------------------------
Function Get_Tag(objDB, tagName)
Dim objRow

	Get_Tag    = "--"
	Set objRow = objDB.Execute("SELECT * FROM tags WHERE tag_name LIKE '" & "_" & Right(tagName, Len(tagName) - 1) & "'")

	If objRow.Count > 0 Then
		If IsNull(objRow(1)("tag_col")) = False Then
			If objRow(1)("tag_col") <> "" Then
				Get_Tag = objRow(1)("tag_col")
			End If
		End If
	End If

	Set objRow = Nothing
End Function


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Function Get_Item(objRow, Row, ItemLabel)
Dim Itemvalue

	Get_Item = "--"
	If objRow.Count > 0 Then
		If IsNull(objRow(Row)(ItemLabel)) = False Then
			ItemValue = objRow(Row)(ItemLabel)
			If ItemValue <> "" Then
				Get_Item = ItemValue
			End If
		End If
	End If
End Function


'-------------------------------------------------------
'- Format Data (Seconds) to include leading 0's --------
'-------------------------------------------------------
Function L_Pad(Data, Length, Char)

	L_Pad = String(Length - Len(Data), Char) & Data
End Function