Option Explicit
'On Error Resume Next

Dim Dinfo
Dim OSObject
Dim LastBootupTime
Dim StartFlag
Dim strIPAddress
Dim strHostname

StartFlag = True

For Each OSObject In GetObject ("winmgmts:").InstancesOf ("Win32_OperatingSystem")
	LastBootupTime = PC_DateStringToDate(OSObject.LastBootUpTime) 
Next 

Do
	Sleep 1
	If GetPropertyValue ("PC Informatie.Action") = "Check Info" Then
		SetPropertyValue "PC Informatie.Action", "Wait for check"
		Dinfo = ""
		Call Drive_Info(Dinfo)
		Call UpTime_Info(Dinfo, LastBootupTime)
		Call Memory_Info(Dinfo)
		Call CoolAndQuiet_Info(Dinfo)
		Call IP_Info(Dinfo, strIPAddress, strHostname)
	End If
Loop


'-------------------------------------------------------
'- Drive Informatie ------------------------------------
'-------------------------------------------------------
Sub Drive_Info(Dinfo)
Dim objFSO
Dim Drv
Dim Dname
Dim Dfree
Dim Dtot
Dim Dpct
Dim Dused
Dim RecordTime

	Set objFSO = CreateObject("Scripting.FileSystemObject")

	For each Drv in objFSO.Drives
		Select Case Drv.DriveType
			Case 2:	Dfree = Round(Drv.FreeSpace / (1024 ^ 3), 1) & " GB"
				Dtot  = Round(Drv.TotalSize / (1024 ^ 3), 1) & " GB"
				Dused = Round((Drv.TotalSize - Drv.FreeSpace) / (1024 ^ 3), 1) & " GB"
				Dpct  = FormatPercent(Drv.FreeSpace / Drv.TotalSize, 1)
				Dinfo = Dinfo & vbLF & vbTAB & "Drive " & Drv.DriveLetter & ":" & vbTAB & "Totale grootte:"   & vbTAB & Dtot & _
						vbLF & vbTAB        				& vbTAB & "In gebruik:"       & vbTAB & Dused & _
						vbLF & vbTAB 					& vbTAB & "Vrije ruimte:"     & vbTAB & Dfree & _
						vbLF & vbTAB        				& vbTAB & "Procent vrij:"     & vbTAB & Dpct
				If Drv.DriveLetter = "D" Then
					RecordTime = CStr(CInt(Round(Drv.FreeSpace / (1024 ^ 3), 1) / 1.5)) & " Uur"
					SetpropertyValue "Meedio.TV HD Recording Time", RecordTime
					Dinfo = Dinfo & vbLF & vbTAB & vbTAB & "TV Opname tijd:" & vbTAB & RecordTime
				End If
				Dinfo = Dinfo & vbLF & vbTAB & vbTAB & vbTAB 'Lege regel toevoegen
			Case 4:	If Drv.IsReady Then
					If Drv.VolumeName = "" Then
						Dname = "No Name"
					Else
						Dname = Drv.VolumeName
					End If
				Else
					Dname = "No Media in CD-Rom"
				End If
				SetpropertyValue "Meedio.DVD Name", DName
				Dinfo = Dinfo & vbLF & vbTAB & "Drive " & Drv.DriveLetter & ":" & vbTAB & "CD/DVD-Rom" & vbTAB & Dname & _
						vbLF & vbTAB                                    & vbTAB & " "          & vbTAB & " "
			End Select
	Next
	
	Set objFSO = Nothing
End Sub


'-------------------------------------------------------
'- UpTime Informatie -----------------------------------
'-------------------------------------------------------
Sub UpTime_Info(Dinfo, LastBootupTime)
Dim HouseBotStartTime
	
	HouseBotStartTime = GetPropertyValue ("PC Informatie.HouseBot Start Time")
	Dinfo             = Dinfo & vbLF & vbTAB & "PC:" & vbTAB & "Boot datum:" & vbTAB & LastBootupTime & _
	               		    vbLF & vbTAB         & vbTAB & "PC Up Tijd:" & vbTAB & Calc_Time(DateDiff("h", LastBootUpTime, Now)) & _
				    vbLF & vbTAB & vbTAB & "HouseBot Up Tijd:"   & vbTAB & Calc_Time(DateDiff("h", HouseBotStartTime, Now))
End Sub


'-------------------------------------------------------
'- Geheugen Informatie ---------------------------------
'-------------------------------------------------------
Sub Memory_Info(Dinfo)
Dim MemObject
'Dim TotalPhysicalMem
'Dim FreePhysicalMem
Dim TotalPageMem
Dim FreePageMem
Dim UsedPageMem

	For Each MemObject In GetObject ("winmgmts:").InstancesOf ("CIM_OperatingSystem")
	'	FreePhysicalMem = MemObject.FreePhysicalMemory
		FreePageMem     = MemObject.FreeSpaceInPagingFiles
	Next
	
	For Each MemObject In GetObject ("winmgmts:").InstancesOf("Win32_LogicalMemoryConfiguration")
	'	TotalPhysicalMem = MemObject.TotalPhysicalMemory
		TotalPageMem     = MemObject.TotalPageFileSpace
		UsedPageMem      = Round(((TotalpageMem - FreePageMem) / 1024), 0)
		Dinfo            = Dinfo & vbLF & vbTAB & vbTAB & "Geheugen gebruik:" & vbTAB & UsedPageMem & " MB"
	Next
End Sub


'-------------------------------------------------------
'- Cool and Quiet Informatie ---------------------------
'-------------------------------------------------------
Sub CoolAndQuiet_Info(Dinfo)
Dim CoolAndQuiet
	
	CoolAndQuiet = GetPropertyValue ("CNQ Status Script.Cool And Quiet")
	Dinfo        = Dinfo & vbLF & vbTAB & vbTAB & "Cool and Quiet:" & vbTAB & CoolAndQuiet
End Sub


'-------------------------------------------------------
'- IP en HostName Informatie ---------------------------
'-------------------------------------------------------
Sub IP_Info(Dinfo, strIPAddress, strHostname)
Const cstrShowMyIP = "http://www.showmyip.com/xml/" 
Dim objRemXML
Dim objMyIP

	'Onderstaande timer staat hier omdat de site waar het IP adres wordt verkregen maar maximaal 300 Pings per dag accpeteert!
	If Right(Minute(Now), 1) = "5" or StartFlag = True Then
		StartFlag       = False 'Zodat IPAdres en HostName bij opstart worden gezet!
		Set objRemXML   = CreateObject("Microsoft.XMLDOM")
		objRemXML.async = False
		objRemXML.load(cstrShowMyIP)
		
		On Error Resume Next
		
		If Err.Number = 0 Then
			Set objMyIP = objRemXML.selectSingleNode("/ip_address/ip")
			If Err.Number = 0 Then
				strIPAddress = objMyIP.text
				Set objMyIP  = objRemXML.selectSingleNode("/ip_address/host")
				If Err.Number = 0 Then
					strHostname = objMyIP.text
				Else
					strHostName = "Geen Hostname info"
				End If
			Else
				strIPAdress = "Geen IP info"
				strHostName = "Geen Hostname info"
			End If
		Else
			strIPAdress = "Geen contact"
			strHostName = "Geen contact"
			Err.Clear
		End If
	End If
	
	Dinfo = Dinfo & vbLF & vbTAB & vbTAB & "IP Adres:" & vbTAB & strIPAddress & _
			vbLF & vbTAB & vbTAB & "Hostname:" & vbTAB & strHostname
	SetPropertyValue "PC Informatie.Log PC Informatie", Dinfo
	Set objMyIP   = Nothing
	Set objRemXML = Nothing
End Sub


'-------------------------------------------------------
'- Functie voor UpTime Informatie ----------------------
'-------------------------------------------------------
Function PC_DateStringToDate(Bootup)
	PC_DateStringToDate = CDate(Mid(Bootup, 7, 2) & "/" & Mid(Bootup, 5, 2) & "/" & Left(Bootup, 4) _ 
	& " " & Mid (Bootup, 9, 2) & ":" & Mid(Bootup, 11, 2) & ":" & Mid(Bootup, 13, 2)) 
End Function


'-------------------------------------------------------
'- Functie voor tijdsduur berekening -------------------
'-------------------------------------------------------
Function Calc_Time(Hours)
	Select Case True
		Case Hours < 24: 
			Calc_Time = CStr(Hours) & " Uur"
			Exit Function
		Case Hours < 48:
			Calc_Time = "1 Dag en " & CStr(Hours - 24) & " Uur"
			Exit Function
		Case Else:
			Calc_Time = CStr(Hours \ 24) & " Dagen en " & CStr(Hours - ((Hours \ 24) * 24)) & " Uur"
	End Select
End Function