Option Explicit
'On Error Resume Next

Dim Action
Dim ReceivedData
Dim OldReceivedData
Dim HexBytes()
Dim DecBytes()


'-------------------------------------------------------
'- Main: Checks Received Data and Handles Send Data ----
'-------------------------------------------------------
Do
	Sleep 1
	ReceivedData = GetPropertyValue ("Plasma TV.Received Data")
	If OldReceivedData <> ReceivedData Then
		OldReceivedData = ReceivedData
		Call Handle_ReceivedData(ReceivedData)
	End If
	
	Action = GetPropertyValue ("Plasma Status.Action")
	If Action <> "Waiting" Then
		SetpropertyValue "Plasma Status.Action", "Waiting"
		Sleep 100
		If Action <> "" Then
			Call Handle_SendData(Action)
		End If
	End If
Loop


'-------------------------------------------------------
Sub Handle_ReceivedData(Data)
Dim nit
Dim Message
Dim Length
Dim Value
Dim HexData

	Message = ""
	Length  = Len(ReceivedData)

	ReDim HexBytes(Length)
	ReDim DecBytes(Length)

	If Length > 4 Then
		For nit = 1 to Length
			Value = Asc(Mid(Data, nit, 1))
			
			If Value = 255 Then	'255 Wordt gereset naar 0 omdat in HouseBot het 0-character wordt gezien als 255
				Value = 0
			End If
			
			HexData       = Hex(Value)
			DecBytes(nit) = Value
			
			If Value < 16 Then
				Message       = Message + "0" + HexData
				HexBytes(nit) = "0" + HexData
			Else
				Message       = Message + HexData
				HexBytes(nit) = HexData
			End If
			
			If nit < Length Then 
				Message = Message + " "
			End If
		Next
	
		'MsgBo "Reply: " & Message
	
		Select Case HexBytes(4)
			Case "4F", "4E": Call Rx_Power(Message)
			Case "3F", "3E": Call Rx_Mute(Message)
			Case "51"      : Call Rx_ScreenMode(Message)
			Case "47"      : Call Rx_InputModeRequest(Message)
			Case "41"      : Call Rx_InputMode(Message)
			Case "0A"      : Call Rx_PictureMode(Message)
			Case "7F"      : Call Rx_Autopicture(Message)
			Case "C1"      : Call Rx_CinemaMode(Message)
			Case "58"      : Call Rx_OSMSet(Message)
			Case "8B"      : Call Rx_RGBSelect(Message)
			Case "07"      : Call Rx_MultiScreen(Message)
			Case "C0"      : Call Rx_NRModeSet(Message)
			Case "8A"      : Call Rx_HDSelect(Message)
			Case "2A"      : Call Rx_PictureSizeSelect(Message)
			Case "1A"      : Call Rx_RGB3AdjustSelect(Message)
			Case "70"      :      SetPropertyValue "Plasma Status.Action", "Request_Audio Select" '3F 60 80 70 00 8F
			Case "5C"      : Call Rx_ColorSystemSelect(Message)
			Case "8E"      : Call Rx_PlugAndPlayDVI(Message)
			Case "26"      : Call Rx_SetPlasmaFrequencyState(Message)
			Case "3F"      : Call Rx_SetPlasmaFailureModeState(Message)
			Case "6F"      : Call Rx_SetPlasmaAudioSelectState(Message)
			Case "17"      : Call Rx_SetPlasmaModelName(Message, Length)
			Case "45"      : Call Rx_SetPlasmaVideoAdjustState(Message, Length)
		End Select
	End If
End Sub


'-------------------------------------------------------
Sub Handle_SendData(Action)
Dim Data

	Data = Split(Action, "_") 'Typical Data "Power_On"
	Select Case Data(0)
		Case "Power"      : Call Tx_Power(Data(1))
		Case "Mute"       : Call Tx_Mute(Data(1))
		Case "Volume"     : Call Tx_Volume(Data(1))
		Case "Input"      : Call Tx_InputSelect(Data(1))
		Case "PictureMode": Call Tx_PictureMode(Data(1))
		Case "ScreenMode" : Call Tx_ScreenMode(Data(1))
		Case "HDSelect"   : Call Tx_HDSelect(Data(1))
		Case "RGBSelect"  : Call Tx_RGBSelect(Data(1))
		Case "RGB3Adjust" : Call Tx_RGB3Adjust(Data(1)) 
		Case "NRMode"     : Call Tx_NRMode(Data(1))
		Case "PNPDVI"     : Call Tx_PNPDVI(Data(1))
		Case "V-Position" : SetPropertyValue "Plasma TV.Send Data", "DF80607F030301F53A" 'Hardcoded to -11
		Case "MultiScreen": Call Tx_MultiScreen(Data(1))
		Case "AudioSelect": Call Tx_AudioSelect(Data(1))
		Case "AutoPicture": Call Tx_AutoPicture(Data(1))
		Case "PictureSize": Call Tx_PictureSize(Data(1))
		Case "CinemaMode" : Call Tx_CinemaMode(Data(1))
		Case "OSMSet"     : Call Tx_OSMSet(Data(1))
		Case "ColorSystem": Call Tx_ColorSystem(Data(1))
		Case "Request"    : Call Tx_Request(Data(1))
	End Select
End Sub


'-------------------------------------------------------
'- Subs and Functions below are for Received Data ------
'-------------------------------------------------------
'- Set Power State -------------------------------------
'-------------------------------------------------------
Sub Rx_Power(State)
	Select Case State
		Case "3F 60 80 4F 00 6E": SetPropertyValue "Plasma Status.Power", "Off"
		Case "3F 60 80 4E 00 6D": SetPropertyValue "Plasma Status.Power", "On"
	End Select
End Sub


'-------------------- Mute -----------------------------
Sub Rx_Mute(State)
	Select Case State
		Case "3F 60 80 3F 00 5E": SetPropertyValue "Plasma Status.Audio Mute", "Off"
		Case "3F 60 80 3E 00 5D": SetPropertyValue "Plasma Status.Audio Mute", "On"
	End Select
End Sub


'-------------------- Screen Mode ----------------------
Sub Rx_ScreenMode(State)
	Select Case State
		Case "7F 60 80 51 01 02 B3": SetPropertyValue "Plasma Status.Screen Mode", "Stadium"
		Case "7F 60 80 51 01 03 B4": SetPropertyValue "Plasma Status.Screen Mode", "Zoom"
		Case "7F 60 80 51 01 04 B5": SetPropertyValue "Plasma Status.Screen Mode", "Normal"
		Case "7F 60 80 51 01 05 B6": SetPropertyValue "Plasma Status.Screen Mode", "Anamorphic"
		Case "7F 60 80 51 01 09 BA": SetPropertyValue "Plasma Status.Screen Mode", "14:9"
		Case "7F 60 80 51 01 0A BB": SetPropertyValue "Plasma Status.Screen Mode", "2.35:1"
	End Select
End Sub


'-------------------- Input Mode Request ---------------
Sub Rx_InputModeRequest(State)
	Select Case State
		Case "3B 60 80 47 00 62": SetPropertyValue "Plasma Status.Action", "Request_Input Mode"
		Case "3F 60 80 47 00 66": SetPropertyValue "Plasma Status.Action", "Request_Input Mode"
	End Select
End Sub


'-------------------- Input Mode -----------------------
Sub Rx_InputMode(State)
	Select Case State
		Case "7F 60 80 41 01 01 A2": SetPropertyValue "Plasma Status.Input Mode", "Video 1 (BNC)"
		Case "7F 60 80 41 01 02 A3": SetPropertyValue "Plasma Status.Input Mode", "Video 2 (RCA)"
		Case "7F 60 80 41 01 03 A4": SetPropertyValue "Plasma Status.Input Mode", "Video 3 (S-Video)"
		Case "7F 60 80 41 01 04 A5": SetPropertyValue "Plasma Status.Input Mode", "HD"
		Case "7F 60 80 41 01 05 A6": SetPropertyValue "Plasma Status.Input Mode", "RGB 1 (VGA)"
		Case "7F 60 80 41 01 06 A7": SetPropertyValue "Plasma Status.Input Mode", "RGB 2/PC2"
		Case "7F 60 80 41 01 0A AB": SetPropertyValue "Plasma Status.Input Mode", "Component (RCA)"
		Case "7F 60 80 41 01 0C AD": SetPropertyValue "Plasma Status.Input Mode", "HD 2"
		Case "7F 60 80 41 01 0D AE": SetPropertyValue "Plasma Status.Input Mode", "Scart 1 (BNC)"
		Case "7F 60 80 41 01 0E AF": SetPropertyValue "Plasma Status.Input Mode", "RGB 3 (DVI)"
		Case "7F 60 80 41 01 10 B1": SetPropertyValue "Plasma Status.Input Mode", "HD 3 (DVI)"
	End Select
	SetPropertyValue "Plasma Status.Action", "Request_Frequency"
End Sub


'-------------------- Picture Mode ---------------------
Sub Rx_PictureMode(State)
	Select Case State
		Case "7F 60 80 0A 01 01 6B": SetPropertyValue "Plasma Status.Picture Mode", "Normal"
		Case "7F 60 80 0A 01 02 6C": SetPropertyValue "Plasma Status.Picture Mode", "Theater 1"
		Case "7F 60 80 0A 01 03 6D": SetPropertyValue "Plasma Status.Picture Mode", "Theater 2"
		Case "7F 60 80 0A 01 04 6E": SetPropertyValue "Plasma Status.Picture Mode", "Default"
		Case "7F 60 80 0A 01 05 6F": SetPropertyValue "Plasma Status.Picture Mode", "Bright"
	End Select
End Sub

	
'-------------------- Auto Picture ---------------------
Sub Rx_AutoPicture(State)
	Select Case State
		Case "7F 60 80 7F 03 03 09 00 ED": SetPropertyValue "Plasma Status.Auto Picture", "Off"
		Case "7F 60 80 7F 03 03 09 00 EE": SetPropertyValue "Plasma Status.Auto Picture", "On"
	End Select
End Sub


'-------------------- Cinema Mode ----------------------
Sub Rx_CinemaMode(State)
	Select Case State
		Case "7F 60 80 C1 01 02 23": SetPropertyValue "Plasma Status.Cinema Mode", "Off"
		Case "7F 60 80 C1 01 01 22": SetPropertyValue "Plasma Status.Cinema Mode", "On"
	End Select
End Sub


'-------------------- OSM Set --------------------------
Sub Rx_OSMSet(State)
	Select Case State
		Case "7F 60 80 58 01 02 BA": SetPropertyValue "Plasma Status.OSM Set", "Off"
		Case "7F 60 80 58 01 01 B9": SetPropertyValue "Plasma Status.OSM Set", "On"
	End Select
End Sub


'-------------------- RGB Select -----------------------
Sub Rx_RGBSelect(State)
	Select Case State
		Case "7F 60 80 8B 01 01 EC": SetPropertyValue "Plasma Status.RGB Select", "Auto"
		Case "7F 60 80 8B 01 02 ED": SetPropertyValue "Plasma Status.RGB Select", "Still"
		Case "7F 60 80 8B 01 03 EE": SetPropertyValue "Plasma Status.RGB Select", "Motion"
		Case "7F 60 80 8B 01 04 EF": SetPropertyValue "Plasma Status.RGB Select", "Wide 1"
		Case "7F 60 80 8B 01 05 F0": SetPropertyValue "Plasma Status.RGB Select", "Wide 2"
		Case "7F 60 80 8B 01 06 F1": SetPropertyValue "Plasma Status.RGB Select", "DTV"
		Case "7F 60 80 8B 01 07 F2": SetPropertyValue "Plasma Status.RGB Select", "Wide 3"
		Case "7F 60 80 8B 01 08 F3": SetPropertyValue "Plasma Status.RGB Select", "Wide 4"
	End Select
	SetPropertyValue "Plasma Status.Action", "Request_Frequency"
End Sub


'-------------------- Multi Screen ---------------------
Sub Rx_MultiScreen(State)
	Select Case State
		Case "7F 60 80 07 01 00 67": SetPropertyValue "Plasma Status.Multi Screen", "Single Screen"
		Case "7F 60 80 07 01 01 68": SetPropertyValue "Plasma Status.Multi Screen", "Side by Side 1"
		Case "7F 60 80 07 01 02 69": SetPropertyValue "Plasma Status.Multi Screen", "Side by Side 2R"
		Case "7F 60 80 07 01 03 6A": SetPropertyValue "Plasma Status.Multi Screen", "PiP 1 BL 1"
		Case "7F 60 80 07 01 04 6B": SetPropertyValue "Plasma Status.Multi Screen", "PiP 2 BR 1"
		Case "7F 60 80 07 01 05 6C": SetPropertyValue "Plasma Status.Multi Screen", "Side by Side 2L"
		Case "7F 60 80 07 01 06 6D": SetPropertyValue "Plasma Status.Multi Screen", "PiP 1 BL 2"
		Case "7F 60 80 07 01 07 6E": SetPropertyValue "Plasma Status.Multi Screen", "PiP 2 BR 2"
		Case "7F 60 80 07 01 08 6F": SetPropertyValue "Plasma Status.Multi Screen", "PiP 1 BL 3"
		Case "7F 60 80 07 01 09 70": SetPropertyValue "Plasma Status.Multi Screen", "PiP 2 BR 3"
		Case "7F 60 80 07 01 0A 71": SetPropertyValue "Plasma Status.Multi Screen", "PiP 1 BL 4"
		Case "7F 60 80 07 01 0B 72": SetPropertyValue "Plasma Status.Multi Screen", "PiP 2 BR 4"
		Case "7F 60 80 07 01 41 A8": SetPropertyValue "Plasma Status.Multi Screen", "PiP 3 TR 1"
		Case "7F 60 80 07 01 42 A9": SetPropertyValue "Plasma Status.Multi Screen", "PiP 3 TR 2"
		Case "7F 60 80 07 01 43 AA": SetPropertyValue "Plasma Status.Multi Screen", "PiP 3 TR 3"
		Case "7F 60 80 07 01 44 AB": SetPropertyValue "Plasma Status.Multi Screen", "PiP 3 TR 4"
		Case "7F 60 80 07 01 45 AC": SetPropertyValue "Plasma Status.Multi Screen", "PiP 4 TL 1"
		Case "7F 60 80 07 01 46 AD": SetPropertyValue "Plasma Status.Multi Screen", "PiP 4 TL 2"
		Case "7F 60 80 07 01 47 AE": SetPropertyValue "Plasma Status.Multi Screen", "PiP 4 TL 3"
		Case "7F 60 80 07 01 48 AF": SetPropertyValue "Plasma Status.Multi Screen", "PiP 4 TL 4"
		Case "7F 60 80 07 01 49 B0": SetPropertyValue "Plasma Status.Multi Screen", "Side by Side 3"
		Case "7F 60 80 07 01 4A B1": SetPropertyValue "Plasma Status.Multi Screen", "Side by Side 4R"
		Case "7F 60 80 07 01 4B B2": SetPropertyValue "Plasma Status.Multi Screen", "Side by Side 4L"
		Case "7F 60 80 07 01 20 87": SetPropertyValue "Plasma Status.Multi Screen", "Active Left"
		Case "7F 60 80 07 01 21 88": SetPropertyValue "Plasma Status.Multi Screen", "Active Right"
		Case "7F 60 80 07 01 30 97": SetPropertyValue "Plasma Status.Multi Screen", "Active Main"
		Case "7F 60 80 07 01 31 98": SetPropertyValue "Plasma Status.Multi Screen", "Active Sub"
	End Select
End Sub


'-------------------- NR Mode Set ----------------------
Sub Rx_NRModeSet(State)
	Select Case State
		Case "7F 60 80 C0 01 01 21": SetPropertyValue "Plasma Status.NR Mode Set", "Off"
		Case "7F 60 80 C0 01 02 22": SetPropertyValue "Plasma Status.NR Mode Set", "NR-1"
		Case "7F 60 80 C0 01 03 23": SetPropertyValue "Plasma Status.NR Mode Set", "NR-2"
		Case "7F 60 80 C0 01 04 24": SetPropertyValue "Plasma Status.NR Mode Set", "NR-3"
	End Select
End Sub


'-------------------- HD Select ------------------------
Sub Rx_HDSelect(State)
	Select Case State
		Case "7F 60 80 8A 01 01 EB": SetPropertyValue "Plasma Status.HD Select", "1035i"
		Case "7F 60 80 8A 01 02 EC": SetPropertyValue "Plasma Status.HD Select", "540p"
		Case "7F 60 80 8A 01 03 ED": SetPropertyValue "Plasma Status.HD Select", "1080i"
	End Select
End Sub


'-------------------- Picture Size Select --------------
Sub Rx_PictureSizeSelect(State)
	Select Case State
		Case "7F 60 80 2A 01 01 8B": SetPropertyValue "Plasma Status.Picture Size Select", "On"
		Case "7F 60 80 2A 01 02 8C": SetPropertyValue "Plasma Status.Picture Size Select", "Off"
	End Select
End Sub


'-------------------- RGB3 Adjust Select ---------------
Sub Rx_RGB3AdjustSelect(State)
	Select Case State
		Case "7F 60 80 1A 02 06 01 82": SetPropertyValue "Plasma Status.RGB3 Adjust Select", "1"
		Case "7F 60 80 1A 02 06 02 83": SetPropertyValue "Plasma Status.RGB3 Adjust Select", "2"
		Case "7F 60 80 1A 02 06 03 84":	SetPropertyValue "Plasma Status.RGB3 Adjust Select", "3"
	End Select
End Sub


'-------------------- Color System Select --------------
Sub Rx_ColorSystemSelect(State)
	Select Case State
		Case "7F 60 80 5C 01 01 BD": SetPropertyValue "Plasma Status.Color System", "3.58NTSC"
		Case "7F 60 80 5C 01 02 BE": SetPropertyValue "Plasma Status.Color System", "4.43NTSC"
		Case "7F 60 80 5C 01 03 BF": SetPropertyValue "Plasma Status.Color System", "PAL"
		Case "7F 60 80 5C 01 04 C0": SetPropertyValue "Plasma Status.Color System", "SECAM"
		Case "7F 60 80 5C 01 0A C6": SetPropertyValue "Plasma Status.Color System", "Auto 1"
		Case "7F 60 80 5C 01 0B C7": SetPropertyValue "Plasma Status.Color System", "PAL60"
		Case "7F 60 80 5C 01 0C C8": SetPropertyValue "Plasma Status.Color System", "Auto 2"
		Case "7F 60 80 5C 01 0D C9": SetPropertyValue "Plasma Status.Color System", "PAL-M"
		Case "7F 60 80 5C 01 0E CA": SetPropertyValue "Plasma Status.Color System", "PAL-N"
	End Select
	SetPropertyValue "Plasma Status.Action", "Request_Frequency"
End Sub


'-------------------- Plug and Play DVI ----------------
Sub Rx_PlugAndPlayDVI(State)
	Select Case State
		Case "7F 60 80 8E 01 01 EF": SetPropertyValue "Plasma Status.Plug and Play DVI", "PC"
		Case "7F 60 80 8E 01 02 F0": SetPropertyValue "Plasma Status.Plug and Play DVI", "STB/DVD"
	End select
End Sub


'--------------------- SetPlasmaFrequencyState ---------
Sub Rx_SetPlasmaFrequencyState(State)

Dim OffSet
Dim HorizontalFreq
Dim VerticalFreq
Dim Pixels
Dim Lines
Dim Resolution

OffSet = 6

	'-------------------- Frequency ----------------
	If DecBytes(OffSet + 0) = 0 Then 
		HorizontalFreq = "No Signal"
		VerticalFreq   = "No Signal"
	Else
		HorizontalFreq = CStr(DecBytes(OffSet + 0)) + "." + CStr(DecBytes(OffSet + 1)) + " KHz"
		VerticalFreq   = CStr(DecBytes(OffSet + 2)) + "." + CStr(DecBytes(OffSet + 3)) + " Hz"
	End If
	SetPropertyValue "Plasma Status.H Frequency", HorizontalFreq
	SetPropertyValue "Plasma Status.V Frequency", VerticalFreq
	
	'-------------------- Horizontal Polarity ------
	Select Case HexBytes(OffSet + 4)
		Case "00": SetPropertyValue "Plasma Status.H Polarity", "-"
		Case "01": SetPropertyValue "Plasma Status.H Polarity", "Positive"
		Case "02": SetPropertyValue "Plasma Status.H Polarity", "Negative"
	End Select
	
	'-------------------- Vertical Polarity --------
	Select Case HexBytes(OffSet + 5)
		Case "00": SetPropertyValue "Plasma Status.V Polarity", "-"
		Case "01": SetPropertyValue "Plasma Status.V Polarity", "Positive"
		Case "02": SetPropertyValue "Plasma Status.V Polarity", "Negative"
	End Select
	
	'-------------------- Resolution ---------------
	Pixels = DecBytes(OffSet +  8) * 256 + DecBytes(OffSet + 7)
	Lines  = DecBytes(OffSet + 10) * 256 + DecBytes(OffSet + 9)
	If Pixels = 0 Then
		Resolution = "---"
	Else
		Resolution = CStr(Pixels) + " x " + CStr(Lines)
	End If
	SetPropertyValue "Plasma Status.Resolution", Resolution
	
	'-------------------- (Color) Mode -------------
	SetPropertyValue "Plasma Status.RGB Memory", "---"
	Select Case HexBytes(OffSet + 6)
		Case "00": SetPropertyValue "Plasma Status.(Color) Mode", "No Signal"
		Case "81": SetPropertyValue "Plasma Status.(Color) Mode", "Video: 3.58NTSC"
		Case "82": SetPropertyValue "Plasma Status.(Color) Mode", "Video: 4.43NTSC"
		Case "83": SetPropertyValue "Plasma Status.(Color) Mode", "Video: PAL"
		Case "84": SetPropertyValue "Plasma Status.(Color) Mode", "Video: PAL-M"
		Case "85": SetPropertyValue "Plasma Status.(Color) Mode", "Video: PAL-N"
		Case "86": SetPropertyValue "Plasma Status.(Color) Mode", "Video: PAL60"
		Case "87": SetPropertyValue "Plasma Status.(Color) Mode", "Video: SECAM"
		Case "88": SetPropertyValue "Plasma Status.(Color) Mode", "Video: B/W60"
		Case "89": SetPropertyValue "Plasma Status.(Color) Mode", "Video: B/W50"
		Case "A0": SetPropertyValue "Plasma Status.(Color) Mode", "HD/DVD/DTV: 480i"
		Case "A1": SetPropertyValue "Plasma Status.(Color) Mode", "HD/DVD/DTV: 480p"
		Case "A2": SetPropertyValue "Plasma Status.(Color) Mode", "HD/DVD/DTV: 576i"
		Case "A3": SetPropertyValue "Plasma Status.(Color) Mode", "HD/DVD/DTV: 576p"
		Case "A4": SetPropertyValue "Plasma Status.(Color) Mode", "HD/DVD/DTV: 720p"
		Case "A5": SetPropertyValue "Plasma Status.(Color) Mode", "HD/DVD/DTV: 1035i"
		Case "A6": SetPropertyValue "Plasma Status.(Color) Mode", "HD/DVD/DTV: 1080i"
		Case Else: SetPropertyValue "Plasma Status.(Color) Mode", "RGB Signal"
			   SetPropertyValue "Plasma Status.RGB Memory", DecBytes(OffSet + 6)
	End Select
End Sub


'--------------------- SetPlasmaFailureModeState -------
Sub Rx_SetPlasmaFailureModeState(State)
'Als alles goed is, is DecBytes(6) gelijk aan 0xFF. 0xFF wordt boven in dit script omgezet in 0x00 vanwege de HouseBot 0-byte termination

Dim PDP_Module
Dim Temperature
Dim Fan

	If DecBytes(6) = 0 Then
		SetPropertyValue "Plasma Status.PDP Module", "Normaal"
		SetPropertyValue "Plasma Status.Temperature", "Normaal"
		SetPropertyValue "Plasma Status.Fan", "Normaal"
	Else
		PDP_Module  = DecBytes(6) and 1
		Temperature = DecBytes(6) and 4
		Fan         = DecBytes(6) and 8

		If PDP_Module = 0 Then
			SetPropertyValue "Plasma Status.PDP Module", "Abnormaal"
		Else
			SetPropertyValue "Plasma Status.PDP Module", "Normaal"
		End If
        	
		If Temperature = 0 Then
			SetPropertyValue "Plasma Status.Temperature", "Abnormaal"
		Else
			SetPropertyValue "Plasma Status.Temperature", "Normaal"
		End If
        	
		If Fan = 0 Then
			SetPropertyValue "Plasma Status.Fan", "Abnormaal"
		Else
			SetPropertyValue "Plasma Status.Fan", "Normaal"
		End If
	End If
End Sub


'--------------------- SetPlasmaAudioSelectState -------
Sub Rx_SetPlasmaAudioSelectState(State)
Dim nit
Dim OffSet
Dim PropertyVal
Dim Source

OffSet = 5
	For nit = 1 to 3
		PropertyVal = "Plasma Status.Audio Input " + CStr(nit)
		Select Case HexBytes(OffSet + nit)
			Case "01": Source = "Video 1 (BNC)"
			Case "02": Source = "Video 2 (RCA)"
			Case "03": Source = "Video 3 (SVid)"
			Case "05": Source = "Comp. (RCA)"
			Case "06": Source = "Scart 1 (BNC)"
			Case "07": Source = "RGB 1 (VGA)"
			Case "08": Source = "RGB 2"
			Case "0C": Source = "RGB 3 (DVI)"
			Case "0E": Source = "HD 3 (DVI)"
			Case Else: Source = "---"
		End Select
		SetPropertyValue PropertyVal, Source
	Next
End Sub


'--------------------- SetPlasmaModelName --------------
Sub Rx_SetPlasmaModelName(State, StrLen)
Dim nit
Dim OffSet
Dim Value
Dim AsciiOffset
Dim ModelName

Offset = 6
	If StrLen = 18 Then
		For nit = Offset To (Offset + 11)
			Value = DecBytes(nit)
			Select Case True
				Case Value >= 0  And Value <= 9 : AsciiOffset = 48   '0 t/m 9
				Case Value >= 16 And Value <= 41: AsciiOffset = 49   'A t/m Z
				Case Value = 150		: AsciiOffset = -118 'Spatie
				Case Else			: AsciiOffset = -83  'Streepje
			End Select
			ModelName = ModelName + Chr(Value + AsciiOffset)
		Next
		SetPropertyValue "Plasma Status.Model Name", ModelName
	End If
End Sub


'--------------------- SetPlasmaVideoAdjustState -------
Sub Rx_SetPlasmaVideoAdjustState(State, StrLen)
Dim nit
Dim Datas(15)
Dim OffSet
Dim Value
Dim PropertyValue

Offset    = 6
Datas(0)  = "Red Gain(Bias)"
Datas(1)  = "Green Gain(Bias)"
Datas(2)  = "Blue Gain(Bias)"
Datas(3)  = "Color Gain"
Datas(4)  = "Tint Gain"
Datas(5)  = "Sharpness Gain"
Datas(6)  = "Contrast Gain"
Datas(7)  = "Bright Gain"
Datas(8)  = "Red Gain(Drive)"
Datas(9)  = "Green Gain(Drive)"
Datas(10) = "Blue Gain(Drive)"
Datas(11) = "Color Temp"

	If StrLen = 18 Then
		For nit = 0 To 10
			Value = DecBytes(Offset + nit)		
			If Value >= 204 And Value <= 255 Then
				Value = Value - 256
			End If
			PropertyValue = "Plasma Status." + Datas(nit)
			'SetPropertyValue PropertyValue, Value
			'MsgBox Value
		Next

		Value         = DecBytes(Offset + nit)
		PropertyValue = "Plasma Status." + Datas(nit)
		Select Case Value
			Case 0   : Value = "Low"
			Case 1   : Value = "Middle Low"
			Case 2   : Value = "Middle"
			Case 3   : Value = "High"
			Case Else: Value = "---"
		End Select
		'SetPropertyValue PropertyValue, Value
	End If
End Sub


'-------------------------------------------------------
'- Subs and Functions below are for Send Data ----------
'-------------------------------------------------------
'- Power -----------------------------------------------
'-------------------------------------------------------
Sub Tx_Power(Data)

	Select Case Data
		Case "On" : SetPropertyValue "Plasma TV.Send Data", "9F80604E00CD"
		Case "Off": SetPropertyValue "Plasma TV.Send Data", "9F80604F00CE"
	End Select
End Sub


'-------------------------------------------------------
'- Audio Mute ------------------------------------------
'-------------------------------------------------------
Sub Tx_Mute(Data)

	Select Case Data
		Case "On" : SetPropertyValue "Plasma TV.Send Data", "9F80603E00BD"
		Case "Off": SetPropertyValue "Plasma TV.Send Data", "9F80603F00BE"
	End Select
End Sub


'-------------------------------------------------------
'- Volume -> Last 4 bytes are set in Plasma Volume Buttons.vbs (Volume + Checksum)
'-------------------------------------------------------
Sub Tx_Volume(Data)

	SetPropertyValue "Plasma TV.Send Data", "DF80607F030501" & Data
End Sub


'-------------------------------------------------------
'- Input Select ----------------------------------------
'-------------------------------------------------------
Sub Tx_InputSelect(Data)

	Select Case Data
		Case "Video 1 (BNC)"  : SetPropertyValue "Plasma TV.Send Data", "DF806047010108"
		Case "Video 2 (RCA)"  : SetPropertyValue "Plasma TV.Send Data", "DF806047010209"
		Case "Video 3 (SVHS)" : SetPropertyValue "Plasma TV.Send Data", "DF80604701030A"
		Case "Component (RCA)": SetPropertyValue "Plasma TV.Send Data", "DF80604701050C"
		Case "Scart 1 (BNC)"  : SetPropertyValue "Plasma TV.Send Data", "DF80604701060D"
		Case "RGB 1 (VGA)"    : SetPropertyValue "Plasma TV.Send Data", "DF80604701070E"
		Case "RGB 2 / PC 2"   : SetPropertyValue "Plasma TV.Send Data", "DF80604701080F"
		Case "RGB 3 (DVI)"    : SetPropertyValue "Plasma TV.Send Data", "DF806047010C13"
		Case "HD 3 (DVI)"     : SetPropertyValue "Plasma TV.Send Data", "DF806047010E15"
	End Select
End Sub


'-------------------------------------------------------
'- Picture Mode ----------------------------------------
'-------------------------------------------------------
Sub Tx_PictureMode(Data)

	Select Case Data
		Case "Normal"   : SetPropertyValue "Plasma TV.Send Data", "DF80600A0101CB"
		Case "Theater 1": SetPropertyValue "Plasma TV.Send Data", "DF80600A0102CC"
		Case "Theater 2": SetPropertyValue "Plasma TV.Send Data", "DF80600A0103CD"
		Case "Default"  : SetPropertyValue "Plasma TV.Send Data", "DF80600A0104CE"
		Case "Bright"   : SetPropertyValue "Plasma TV.Send Data", "DF80600A0105CF"
	End Select
End Sub


'-------------------------------------------------------
'- Screen Mode ----------------------------------------
'-------------------------------------------------------
Sub Tx_ScreenMode(Data)

	Select Case Data
		Case "Stadium"   : SetPropertyValue "Plasma TV.Send Data", "DF806051010213"
		Case "Zoom"      : SetPropertyValue "Plasma TV.Send Data", "DF806051010314"
		Case "Normal"    : SetPropertyValue "Plasma TV.Send Data", "DF806051010415"
		Case "Anamorphic": SetPropertyValue "Plasma TV.Send Data", "DF806051010516"
		Case "14:9"      : SetPropertyValue "Plasma TV.Send Data", "DF80605101091A"
		Case "2.35:1"    : SetPropertyValue "Plasma TV.Send Data", "DF806051010A1B"
	End Select
End Sub


'-------------------------------------------------------
'- HD Select ------------------------------------------
'-------------------------------------------------------
Sub Tx_HDSelect(Data)

	Select Case Data
		Case "1035i": SetPropertyValue "Plasma TV.Send Data", "DF80608A01014B"
		Case "540p" : SetPropertyValue "Plasma TV.Send Data", "DF80608A01024C"
		Case "1080i": SetPropertyValue "Plasma TV.Send Data", "DF80608A01034D"
	End Select
End Sub


'-------------------------------------------------------
'- RGB Select ------------------------------------------
'-------------------------------------------------------
Sub Tx_RGBSelect(Data)

	Select Case Data
		Case "Auto"  : SetPropertyValue "Plasma TV.Send Data", "DF80608B01014C"
		Case "Still" : SetPropertyValue "Plasma TV.Send Data", "DF80608B01024D"
		Case "Motion": SetPropertyValue "Plasma TV.Send Data", "DF80608B01034E"
		Case "Wide 1": SetPropertyValue "Plasma TV.Send Data", "DF80608B01044F"
		Case "Wide 2": SetPropertyValue "Plasma TV.Send Data", "DF80608B010550"
		Case "Wide 3": SetPropertyValue "Plasma TV.Send Data", "DF80608B010752"
		Case "Wide 4": SetPropertyValue "Plasma TV.Send Data", "DF80608B010853"
		Case "DTV"   : SetPropertyValue "Plasma TV.Send Data", "DF80608B010651"
	End Select
End Sub

'-------------------------------------------------------
'- RGB 3 Adjust Select ---------------------------------
'-------------------------------------------------------
Sub Tx_RGB3Adjust(Data)

	Select Case Data
		Case "Select 1", "DF80601A020601E2"
		Case "Select 2", "DF80601A020602E3"
		Case "Select 3", "DF80601A020603E4"
	End Select
End Sub


'-------------------------------------------------------
'- Noise Reduction Mode --------------------------------
'-------------------------------------------------------
Sub Tx_NRMode(Data)

	Select Case Data
		Case "Off" : SetPropertyValue "Plasma TV.Send Data", "DF8060C0010181"
		Case "NR-1": SetPropertyValue "Plasma TV.Send Data", "DF8060C0010282"
		Case "NR-2": SetPropertyValue "Plasma TV.Send Data", "DF8060C0010383"
		Case "NR-3": SetPropertyValue "Plasma TV.Send Data", "DF8060C0010484"
	End Select
End Sub


'-------------------------------------------------------
'- Plug and play DVI -----------------------------------
'-------------------------------------------------------
Sub Tx_PNPDVI(Data)

	Select Case Data
		Case "PC"     : SetPropertyValue "Plasma TV.Send Data", "DF80608E01014F"
		Case "STB/DVD": SetPropertyValue "Plasma TV.Send Data", "DF80608E010250"
	End Select
End Sub


'-------------------------------------------------------
'- Multi Screen ----------------------------------------
'-------------------------------------------------------
Sub Tx_MultiScreen(Data)

	Select Case Data
		Case "Single Screen"    : SetPropertyValue "Plasma TV.Send Data", "DF8060070100C7"
		Case "SbyS 1"           : SetPropertyValue "Plasma TV.Send Data", "DF8060070101C8"
		Case "SbyS 2R"          : SetPropertyValue "Plasma TV.Send Data", "DF8060070102C9"
		Case "PiP 1 BL 1"       : SetPropertyValue "Plasma TV.Send Data", "DF8060070103CA"
		Case "PiP 2 BR 1"       : SetPropertyValue "Plasma TV.Send Data", "DF8060070104CB"
		Case "SbyS 2L"          : SetPropertyValue "Plasma TV.Send Data", "DF8060070105CC"
		Case "PiP 1 BL 2"       : SetPropertyValue "Plasma TV.Send Data", "DF8060070106CD"
		Case "PiP 2 BR 2"       : SetPropertyValue "Plasma TV.Send Data", "DF8060070107CE"
		Case "PiP 1 BL 3"       : SetPropertyValue "Plasma TV.Send Data", "DF8060070108CF"
		Case "PiP 2 BR 3"       : SetPropertyValue "Plasma TV.Send Data", "DF8060070109D0"
		Case "PiP 1 BL 4"       : SetPropertyValue "Plasma TV.Send Data", "DF806007010AD1"
		Case "PiP 2 BR 4"       : SetPropertyValue "Plasma TV.Send Data", "DF806007010BD2"
		Case "PiP 3 TR 1"       : SetPropertyValue "Plasma TV.Send Data", "DF806007014108"
		Case "PiP 3 TR 2"       : SetPropertyValue "Plasma TV.Send Data", "DF806007014209"
		Case "PiP 3 TR 3"       : SetPropertyValue "Plasma TV.Send Data", "DF80600701430A"
		Case "PiP 3 TR 4"       : SetPropertyValue "Plasma TV.Send Data", "DF80600701440B"
		Case "PiP 4 TL 1"       : SetPropertyValue "Plasma TV.Send Data", "DF80600701450C"
		Case "PiP 4 TL 2"       : SetPropertyValue "Plasma TV.Send Data", "DF80600701460D"
		Case "PiP 4 TL 3"       : SetPropertyValue "Plasma TV.Send Data", "DF80600701470E"
		Case "PiP 4 TL 4"       : SetPropertyValue "Plasma TV.Send Data", "DF80600701480F"
		Case "SbyS 3"           : SetPropertyValue "Plasma TV.Send Data", "DF806007014910"
		Case "SbyS 4R"          : SetPropertyValue "Plasma TV.Send Data", "DF806007014A11"
		Case "SbyS 4L"          : SetPropertyValue "Plasma TV.Send Data", "DF806007014B12"
		Case "SbyS Active Left" : SetPropertyValue "Plasma TV.Send Data", "DF8060070120E7"
		Case "SbyS Active Right": SetPropertyValue "Plasma TV.Send Data", "DF8060070121E8"
		Case "PiP Active Main"  : SetPropertyValue "Plasma TV.Send Data", "DF8060070130F7"
		Case "PiP Active Sub"   : SetPropertyValue "Plasma TV.Send Data", "DF8060070131F8"
	End Select
End Sub


'-------------------------------------------------------
'- Audio Select Set ------------------------------------
'-------------------------------------------------------
Sub Tx_AudioSelect(Data)

	Select Case Data
		Case "Audio1 - Video1"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002010133"
		Case "Audio1 - Video2"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002010234"
		Case "Audio1 - Video3"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002010335"
		Case "Audio1 - Component RCA": SetPropertyValue "Plasma TV.Send Data", "DF80607002010537"
		Case "Audio1 - Scart1 BNC"   : SetPropertyValue "Plasma TV.Send Data", "DF80607002010638"
		Case "Audio1 - RGB1 VGA"     : SetPropertyValue "Plasma TV.Send Data", "DF80607002010739"
		Case "Audio1 - RGB3 DVI"     : SetPropertyValue "Plasma TV.Send Data", "DF80607002010C3E"
		Case "Audio1 - HD3 DVI"      : SetPropertyValue "Plasma TV.Send Data", "DF80607002010E40"
		Case "Audio2 - Video1"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002020134"
		Case "Audio2 - Video2"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002020235"
		Case "Audio2 - Video3"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002020336"
		Case "Audio2 - Component RCA": SetPropertyValue "Plasma TV.Send Data", "DF80607002020538"
		Case "Audio2 - Scart1 BNC"   : SetPropertyValue "Plasma TV.Send Data", "DF80607002020639"
		Case "Audio2 - RGB1 VGA"     : SetPropertyValue "Plasma TV.Send Data", "DF8060700202073A"
		Case "Audio2 - RGB3 DVI"     : SetPropertyValue "Plasma TV.Send Data", "DF80607002020C3F"
		Case "Audio2 - HD3 DVI"      : SetPropertyValue "Plasma TV.Send Data", "DF80607002020E41"
		Case "Audio3 - Video1"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002030135"
		Case "Audio3 - Video2"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002030236"
		Case "Audio3 - Video3"       : SetPropertyValue "Plasma TV.Send Data", "DF80607002030337"
		Case "Audio3 - Component RCA": SetPropertyValue "Plasma TV.Send Data", "DF80607002030539"
		Case "Audio3 - Scart1 BNC"   : SetPropertyValue "Plasma TV.Send Data", "DF8060700203063A"
		Case "Audio3 - RGB1 VGA"     : SetPropertyValue "Plasma TV.Send Data", "DF8060700203073B"
		Case "Audio3 - RGB3 DVI"     : SetPropertyValue "Plasma TV.Send Data", "DF80607002030C40"
		Case "Audio3 - HD3 DVI"      : SetPropertyValue "Plasma TV.Send Data", "DF80607002030E42"
	End Select
End Sub


'-------------------------------------------------------
'- Auto Picture ----------------------------------------
'-------------------------------------------------------
Sub Tx_AutoPicture(Data)

	Select Case Data
		Case "On" : SetPropertyValue "Plasma TV.Send Data", "DF80607F030309004D"
		Case "Off": SetPropertyValue "Plasma TV.Send Data", "DF80607F030309014E"
	End Select
End Sub


'-------------------------------------------------------
'- Auto Picture ----------------------------------------
'-------------------------------------------------------
Sub Tx_PictureSize(Data)

	Select Case Data
		Case "On" : SetPropertyValue "Plasma TV.Send Data", "DF80602A0101EB"
		Case "Off": SetPropertyValue "Plasma TV.Send Data", "DF80602A0102EC"
	End Select
End Sub


'-------------------------------------------------------
'- Cinema Mode -----------------------------------------
'-------------------------------------------------------
Sub Tx_CinemaMode(Data)

	Select Case Data
		Case "On" : SetPropertyValue "Plasma TV.Send Data", "DF8060C1010182"
		Case "Off": SetPropertyValue "Plasma TV.Send Data", "DF8060C1010283"
	End Select
End Sub


'-------------------------------------------------------
'- On Screen Display Mode ------------------------------
'-------------------------------------------------------
Sub Tx_OSMSet(Data)

	Select Case Data
		Case "On" : SetPropertyValue "Plasma TV.Send Data", "DF806058010119"
		Case "Off": SetPropertyValue "Plasma TV.Send Data", "DF80605801021A"
	End Select
End Sub


'-------------------------------------------------------
'- Color System ----------------------------------------
'-------------------------------------------------------
Sub Tx_ColorSystem(Data)

	Select Case Data
		Case "3.58NTSC": SetPropertyValue "Plasma TV.Send Data", "DF80605C01011D"
		Case "4.43NTSC": SetPropertyValue "Plasma TV.Send Data", "DF80605C01021E"
		Case "PAL"     : SetPropertyValue "Plasma TV.Send Data", "DF80605C01031F"
		Case "Secam"   : SetPropertyValue "Plasma TV.Send Data", "DF80605C010420"
		Case "Auto1"   : SetPropertyValue "Plasma TV.Send Data", "DF80605C010A26"
		Case "PAL60"   : SetPropertyValue "Plasma TV.Send Data", "DF80605C010B27"
		Case "Auto2"   : SetPropertyValue "Plasma TV.Send Data", "DF80605C010C28"
		Case "PAL-M"   : SetPropertyValue "Plasma TV.Send Data", "DF80605C010D29"
		Case "PAL-N"   : SetPropertyValue "Plasma TV.Send Data", "DF80605C010E2A"
	End Select
End Sub


'-------------------------------------------------------
'- Color System ----------------------------------------
'-------------------------------------------------------
Sub Tx_Request(Data)

	Select Case Data
		Case "Input Mode"  : SetPropertyValue "Plasma TV.Send Data", "1F8060410040"
		Case "Frequency"   : SetPropertyValue "Plasma TV.Send Data", "1F8060260025%"
		Case "Failure Mode": SetPropertyValue "Plasma TV.Send Data", "1F80603F003E"
		Case "Audio Select": SetPropertyValue "Plasma TV.Send Data", "1F80606F006E"
		Case "Model Name"  : SetPropertyValue "Plasma TV.Send Data", "1F8060170016"
		Case "Video Adjust": SetPropertyValue "Plasma TV.Send Data", "1F8060450044"
	End Select
End Sub
