Option Explicit
'On Error Resume Next

Dim Action
Dim ReceivedData
Dim OldReceivedData
Dim ReceiverMainPower
Dim ReceiverZone2Power
Dim ReceiverZone3Power

ReceiverMainPower  = GetPropertyValue("Receiver Status.Power")
ReceiverZone2Power = GetPropertyValue("Receiver Status.Zone2 Power")
ReceiverZone3Power = GetPropertyValue("Receiver Status.Zone3 Power")


'-------------------------------------------------------
'- Main: Checks Received Data and Handles Send Data ----
'-------------------------------------------------------
Do
	Sleep 1
	ReceivedData = GetPropertyValue ("Receiver.Received Data")
	If OldReceivedData <> ReceivedData Then
		OldReceivedData = ReceivedData
		Call Handle_ReceivedData(ReceivedData)
	End If
	
	Action = GetPropertyValue ("Receiver Status.Action")
	If Action <> "Waiting" Then
		SetpropertyValue "Receiver Status.Action", "Waiting"
		Sleep 100
		If Action <> "" Then
			Call Handle_SendData(Action)
		End If
	End If
Loop


'-------------------------------------------------------
Sub Handle_ReceivedData(Data)
Dim Zone3PwrFlag
Dim DataItem

	Data         = Split(ReceivedData, Chr(26))
	Zone3PwrFlag = False
	
	For each DataItem in Data
		Select Case Left(DataItem, 5)
			Case "!1PWR", "!1ZPW", "!1PW3": Call Rx_PowerState(DataItem)
			Case "!1SLP": Call Rx_SleepState(DataItem)
			Case "!1AMT": Call Rx_MuteState(DataItem)
			Case "!1SPA": Call Rx_SpeakerAState(DataItem)
			Case "!1SPB": Call Rx_SpeakerBState(DataItem)
			Case "!1SLI": Call Rx_InputSelectState(DataItem)
			Case "!1PRS": Call Rx_TunerPresetState(DataItem)
			Case "!1TUN": Call Rx_TunerTuningState(DataItem)
			Case "!1LMD": Call Rx_SurroundModeState(DataItem)
			Case "!1DMD": Call Rx_DigitalModeState(DataItem)
			Case "!1LTN": Call Rx_LateNightState(DataItem)
			Case "!1RAS": Call Rx_ReEQ_AcademyState(DataItem)
			Case "!1DIM": Call Rx_DimState(DataItem)
			Case "!1SLR": Call Rx_RecordSelectState(DataItem) 
			Case "!1SL3": Call Rx_RecordSelectState(DataItem)
				      Zone3PwrFlag = True
			Case "!1ZMT": Call Rx_Zone2MuteState(DataItem)
			Case "!1SLZ": Call Rx_Zone2SelectState(DataItem)
			Case "!1SLA": Call Rx_AudioSelectorState(DataItem)
			Case "!1DIF": Call Rx_DisplayModeCommandState(DataItem)
			Case "!1SET": Call Rx_ProcessSETPCommand(DataItem)
			Case "!1MVL": Call Rx_VolumeState(DataItem)
			Case "!1ZVL": Call Rx_Zone2VolumeState(DataItem)
		End Select
	Next

	If Zone3PwrFlag = True Then 'Dit is een workaround (?) omdat de zone3 power state niet automatisch wordt afegegeven
		SetpropertyValue "Receiver Status.Action", "Power_Zone3 Status" 'Dit commando staat hier zodat het pas na de hele status loop wordt uitgevoerd
		Sleep 500
	End If
End Sub


'-------------------------------------------------------
Sub Handle_SendData(Action)
Dim Data

	Data = Split(Action, "_") 'Typical Data "Dim_Bright" or "Volume_Main Up" 
	Select Case Data(0)
		Case "Power"        : Call Tx_Power(Data(1))
		Case "Sleep"        : Call Tx_Sleep(Data(1))
		Case "Mute"         : Call Tx_Mute(Data(1))
		Case "Speaker"      : Call Tx_Speaker(Data(1))
		Case "Volume"       : Call Tx_Volume(Data(1))
		Case "Selector"     : Call Tx_Selector(Data(1))
		Case "Preset"       : Call Tx_Preset(Data(1))
		Case "Tuning"       : Call Tx_Tuning(Data(1))
		Case "ListeningMode": Call Tx_ListeningMode(Data(1))
		Case "LateNight"    : Call Tx_LateNight(Data(1))
		Case "AudioSelector": Call Tx_AudioSelector(Data(1))
		Case "ReEQ"         : Call Tx_ReEQ(Data(1))
		Case "DigitalMode"  : Call Tx_DigitalMode(Data(1))
		Case "Dim"          : Call Tx_Dim(Data(1))
		Case "OSD"          : Call Tx_OSD(Data(1))
		Case "Display"      : Call Tx_Display(Data(1))
		Case "Trigger"      : Call Tx_Trigger(Data(1))
		Case "NetTune"      : Call Tx_NetTune(Data(1))
		Case "Status"       : Call Tx_Status()
		Case "Wekker"       : Call In_Wekker(Data(1)) 'Own integrated sub to set zone 3 to selected radio station
	End Select
End Sub


'-------------------------------------------------------
'- Subs and Functions below are for Received Data ------
'-------------------------------------------------------
'- Set Power State -------------------------------------
'-------------------------------------------------------
Sub Rx_PowerState(State)
Dim ReceiverPowerLog
Dim ReceiverPower
Dim LogLines
Dim LogCount
Dim nit

	Select Case State
		Case "!1PWR00": ReceiverPower     = "Main Off"
				ReceiverMainPower = "Off"
				SetPropertyValue "Receiver Status.Power", "Off"
				'De Meubel Fan property moet iets anders zijn dan "Off" zodat de fan
				' juist wordt aangestuurd net nadat de receiver is aangezet
				SetPropertyValue "Receiver Status.Meubel Fan", "---"
		Case "!1PWR01":	ReceiverPower     = "Main On"
				ReceiverMainPower = "On"
				SetPropertyValue "Receiver Status.Power", "On"
		Case "!1ZPW00":	ReceiverPower      = "Zone2 Off"
				ReceiverZone2Power = "Off"
				SetPropertyValue "Receiver Status.Zone2 Power", "Off"
		Case "!1ZPW01":	ReceiverPower      = "Zone2 On"
				ReceiverZone2Power = "On"
				SetPropertyValue "Receiver Status.Zone2 Power", "On"
		Case "!1PW300":	ReceiverPower      = "Zone3 Off"
				ReceiverZone3Power = "Off"
				SetPropertyValue "Receiver Status.Zone3 Power", "Off"
		Case "!1PW301":	ReceiverPower = "Zone3 On"
				ReceiverZone3Power = "On"
				SetPropertyValue "Receiver Status.Zone3 Power", "On"
		Case Else     :	ReceiverPower     = "Main ---"
				ReceiverMainPower = "Off"
				SetPropertyValue "Receiver Status.Power", "---"
	End Select
	
	ReceiverPowerLog = GetPropertyValue ("Receiver Status.Log ReceiverPower")

	If ReceiverPowerLog = "Geen items aanwezig" Then
		ReceiverPowerLog = ""
	End If

	LogLines         = Split(ReceiverPowerLog, vbLF)
	LogCount         = UBound(LogLines)
	ReceiverPowerLog = "*S-" & vbTAB & GetPropertyValue("System Time.TimeAndDate") & " - " & ReceiverPower
	
	If LogCount > 50 Then
		LogCount = 50
	End If

	For nit = 0 to LogCount
		LogLines(nit)    = Replace(LogLines(nit), "*S-", "")
		ReceiverPowerLog = ReceiverPowerLog & vbLF & LogLines(nit)
	Next

	SetPropertyValue "Receiver Status.Log ReceiverPower", ReceiverPowerLog
	Call Tx_Selector("Main Status") 'Sets the right state of the Main Source Button Indicators (3 States -> On, Off, Other)
End Sub


'-------------------- Sleep ----------------------------
Sub Rx_SleepState(State)
Dim SleepData
Dim intSleep
Dim strSleep

	SleepData = Right(State, 2)
	intSleep  = (CInt("&H" & Left(SleepData, 1)) * 16) + CInt("&H" & Right(SleepData, 1))
	
	If intSleep = 0 Then 
		strSleep = "Off"
	Else
		strSleep = CStr(intSleep) + " Min"
	End If
	
	SetPropertyValue "Receiver Status.Sleep", strSleep
End Sub


'-------------------- Mute -----------------------------
Sub Rx_MuteState(State)

	Select Case State
		Case "!1AMT00":	SetPropertyValue "Receiver Status.Mute", "Off"
		Case "!1AMT01":	SetPropertyValue "Receiver Status.Mute", "On"
		Case Else     :	SetPropertyValue "Receiver Status.Mute", "---"
	End Select
End Sub


'------------- Set Spreaker A --------------------------
Sub Rx_SpeakerAState(State)

	Select Case State
		Case "!1SPA00":	SetPropertyValue "Receiver Status.Speaker A", "Off"
		Case "!1SPA01":	SetPropertyValue "Receiver Status.Speaker A", "On"
		Case Else     :	SetPropertyValue "Receiver Status.Speaker A", "---"
	End Select
End Sub


'------------- Set Spreaker B --------------------------
Sub Rx_SpeakerBState(State)

	Select Case State
		Case "!1SPB00":	SetPropertyValue "Receiver Status.Speaker B", "Off"
		Case "!1SPB01":	SetPropertyValue "Receiver Status.Speaker B", "On"
		Case Else     :	SetPropertyValue "Receiver Status.Speaker B", "---"
	End Select
End Sub


'-------------------- Input Select ---------------------
Sub Rx_InputSelectState(State)
Dim InputSelect

	Select Case State
		Case "!1SLI00":	InputSelect = "Video 1"
		Case "!1SLI01":	InputSelect = "Video 2"
		Case "!1SLI02":	InputSelect = "Video 3"
		Case "!1SLI03":	InputSelect = "Video 4"
		Case "!1SLI04":	InputSelect = "Video 5"
		Case "!1SLI05":	InputSelect = "Video 6"
		Case "!1SLI06":	InputSelect = "Video 7"
		Case "!1SLI10":	InputSelect = "DVD"
		Case "!1SLI20":	InputSelect = "Tape 1"
		Case "!1SLI21":	InputSelect = "Tape 2"
		Case "!1SLI22":	InputSelect = "Phono"
		Case "!1SLI23":	InputSelect = "CD"
		Case "!1SLI24":	InputSelect = "FM"
		Case "!1SLI25":	InputSelect = "AM"
		Case "!1SLI26":	InputSelect = "Tuner"
		Case "!1SLI27":	InputSelect = "Music Server"
		Case "!1SLI28":	InputSelect = "Internet Radio"
		Case Else     :	InputSelect = "---"
	End Select
	
	SetPropertyValue "Receiver Status.Input Select", InputSelect & " " & ReceiverMainPower
End Sub


'-------------------- Tuner Preset ---------------------
Sub Rx_TunerPresetState(State)

	Select Case State
		Case "!1PRS01":	SetPropertyValue "Receiver Status.Tuner Preset", "1. Radio 2"
		Case "!1PRS02":	SetPropertyValue "Receiver Status.Tuner Preset", "2. Radio 8FM"
		Case "!1PRS03":	SetPropertyValue "Receiver Status.Tuner Preset", "3. Radio 3"
		Case "!1PRS04":	SetPropertyValue "Receiver Status.Tuner Preset", "4. CAZ"
		Case "!1PRS05":	SetPropertyValue "Receiver Status.Tuner Preset", "5. Sky Radio"
		Case "!1PRS06":	SetPropertyValue "Receiver Status.Tuner Preset", "6. Radio 538"
		Case "!1PRS07":	SetPropertyValue "Receiver Status.Tuner Preset", "7. Radio 10FM"
		Case "!1PRS08":	SetPropertyValue "Receiver Status.Tuner Preset", "8. Veronica"
		Case "!1PRS09":	SetPropertyValue "Receiver Status.Tuner Preset", "9. Kink FM"
		Case "!1PRS0A":	SetPropertyValue "Receiver Status.Tuner Preset", "10. Classic"
		Case "!1PRS0B":	SetPropertyValue "Receiver Status.Tuner Preset", "11. Juize FM"
		Case "!1PRS0C":	SetPropertyValue "Receiver Status.Tuner Preset", "12. XFM"
		Case "!1PRS0D":	SetPropertyValue "Receiver Status.Tuner Preset", "13. Arrow"
		Case "!1PRS0E":	SetPropertyValue "Receiver Status.Tuner Preset", "14. Radio 227"
		Case "!1PRS0F":	SetPropertyValue "Receiver Status.Tuner Preset", "15. RTL FM"
		Case "!1PRS10":	SetPropertyValue "Receiver Status.Tuner Preset", "16. Concert"
		Case "!1PRS11":	SetPropertyValue "Receiver Status.Tuner Preset", "17. Q-Music"
		Case "!1PRS12":	SetPropertyValue "Receiver Status.Tuner Preset", "18. Klara"
		Case "!1PRS14":	SetPropertyValue "Receiver Status.Tuner Preset", "20. Slam FM"
		Case Else     :	SetPropertyValue "Receiver Status.Tuner Preset", "---"
	End Select
	SetpropertyValue "Receiver Status.Action", "Tuning_Status"
End Sub


'-------------------- Tuner Manual ---------------------
Sub Rx_TunerTuningState(State)
Dim TuningFreq

	If Mid(State, 6, 1) <> 0 Then
		TuningFreq = TuningFreq + Mid(State, 6, 1)
	End If
	
	TuningFreq = TuningFreq + Mid(State, 7, 1) + Mid(State, 8, 1) + "." + Mid(State, 9, 1) + Mid(State, 10, 1) + " MHz"
	SetPropertyValue "Receiver Status.Tuning", TuningFreq
End Sub


'-------------------- Surround Mode --------------------
Sub Rx_SurroundModeState(State)

	Select Case State
		Case "!1LMD00":	SetPropertyValue "Receiver Status.Surround Mode", "Stereo"
		Case "!1LMD01":	SetPropertyValue "Receiver Status.Surround Mode", "Direct"
		Case "!1LMD02":	SetPropertyValue "Receiver Status.Surround Mode", "Surround"
		Case "!1LMD03":	SetPropertyValue "Receiver Status.Surround Mode", "Film"
		Case "!1LMD04":	SetPropertyValue "Receiver Status.Surround Mode", "THX"
		Case "!1LMD05":	SetPropertyValue "Receiver Status.Surround Mode", "Action"
		Case "!1LMD06":	SetPropertyValue "Receiver Status.Surround Mode", "Musical"
		Case "!1LMD07":	SetPropertyValue "Receiver Status.Surround Mode", "Mono Movie"
		Case "!1LMD08":	SetPropertyValue "Receiver Status.Surround Mode", "Orchestra"
		Case "!1LMD09":	SetPropertyValue "Receiver Status.Surround Mode", "Unplugged"
		Case "!1LMD0A":	SetPropertyValue "Receiver Status.Surround Mode", "Studio Mix"
		Case "!1LMD0B":	SetPropertyValue "Receiver Status.Surround Mode", "TV Logic"
		Case "!1LMD0C":	SetPropertyValue "Receiver Status.Surround Mode", "All Ch Stereo"
		Case "!1LMD0D":	SetPropertyValue "Receiver Status.Surround Mode", "Theater Dimensional"
		Case "!1LMD0E":	SetPropertyValue "Receiver Status.Surround Mode", "Enhance"
		Case "!1LMD0F":	SetPropertyValue "Receiver Status.Surround Mode", "Mono"
		Case "!1LMD11":	SetPropertyValue "Receiver Status.Surround Mode", "Pure Audio"
		Case "!1LMD12":	SetPropertyValue "Receiver Status.Surround Mode", "MultiPlex"
		Case "!1LMD13":	SetPropertyValue "Receiver Status.Surround Mode", "Full Mono"
		Case "!1LMD14":	SetPropertyValue "Receiver Status.Surround Mode", "Dolby VS"
		Case "!1LMD40":	SetPropertyValue "Receiver Status.Surround Mode", "5.1ch Surround"
		Case "!1LMD41":	SetPropertyValue "Receiver Status.Surround Mode", "Dolby EX"
		Case "!1LMD42":	SetPropertyValue "Receiver Status.Surround Mode", "THX Cinema"
		Case "!1LMD43":	SetPropertyValue "Receiver Status.Surround Mode", "THX Surround EX"
		Case "!1LMD50":	SetPropertyValue "Receiver Status.Surround Mode", "THX Ultra2 Cinema"
		Case "!1LMD51":	SetPropertyValue "Receiver Status.Surround Mode", "THX Music Mode"
		Case "!1LMD52":	SetPropertyValue "Receiver Status.Surround Mode", "THX Games Mode"
		Case "!1LMD80":	SetPropertyValue "Receiver Status.Surround Mode", "PLII/PLIIx Movie"
		Case "!1LMD81":	SetPropertyValue "Receiver Status.Surround Mode", "PLII/PLIIx Music"
		Case "!1LMD82":	SetPropertyValue "Receiver Status.Surround Mode", "Neo:6 Cinema"
		Case "!1LMD83":	SetPropertyValue "Receiver Status.Surround Mode", "Neo:6 Music"
		Case "!1LMD84":	SetPropertyValue "Receiver Status.Surround Mode", "PLII/PLIIx THX Cinema"
		Case "!1LMD85":	SetPropertyValue "Receiver Status.Surround Mode", "Neo:6 THX Cinema"
		Case "!1LMD86":	SetPropertyValue "Receiver Status.Surround Mode", "PLII/PLIIx Game"
		Case Else     :	SetPropertyValue "Receiver Status.Surround Mode", "---"
	End Select
End Sub


'-------------------- Digital Mode ---------------------
Sub Rx_DigitalModeState(State)

	Select Case State
		Case "!1DMDANA": SetPropertyValue "Receiver Status.Digital Mode", "Analoog"
		Case "!1DMDPCM": SetPropertyValue "Receiver Status.Digital Mode", "PCM"
		Case "!1DMDDBD": SetPropertyValue "Receiver Status.Digital Mode", "Dolby Digital"
		Case "!1DMDDTS": SetPropertyValue "Receiver Status.Digital Mode", "DTS"
		Case "!1DMDDSC": SetPropertyValue "Receiver Status.Digital Mode", "DTS-ES Discrete"
		Case "!1DMDMTX": SetPropertyValue "Receiver Status.Digital Mode", "DTS-ES Matrix"
		Case "!1DMDMCH": SetPropertyValue "Receiver Status.Digital Mode", "Multi Channel"
		Case Else      : SetPropertyValue "Receiver Status.Digital Mode", "---"
	End Select
End Sub


'-------------------- Late Night -----------------------
Sub Rx_LateNightState(State)

	Select Case State
		Case "!1LTN00":	SetPropertyValue "Receiver Status.Late Night", "Off"
		Case "!1LTN01":	SetPropertyValue "Receiver Status.Late Night", "Low"
		Case "!1LTN02":	SetPropertyValue "Receiver Status.Late Night", "High"
		Case Else     :	SetPropertyValue "Receiver Status.Late Night", "---"
	End Select
End Sub


'-------------------- ReEQ Academy ---------------------
Sub Rx_ReEQ_AcademyState(State)

	Select Case State
		Case "!1RAS00":	SetPropertyValue "Receiver Status.Re-Eq/Academy", "Both Off"
		Case "!1RAS01":	SetPropertyValue "Receiver Status.Re-Eq/Academy", "Re-EQ On"
		Case "!1RAS02":	SetPropertyValue "Receiver Status.Re-Eq/Academy", "Academy On"
		Case Else     :	SetPropertyValue "Receiver Status.Re-Eq/Academy", "---"
	End Select
End Sub


'-------------------- Dim ------------------------------
Sub Rx_DimState(State)

	Select Case State
		Case "!1DIM00":	SetPropertyValue "Receiver Status.Dim", "Bright"
		Case "!1DIM01":	SetPropertyValue "Receiver Status.Dim", "Dim"
		Case "!1DIM02":	SetPropertyValue "Receiver Status.Dim", "Dark"
		Case "!1DIM03":	SetPropertyValue "Receiver Status.Dim", "Off"
		Case Else     :	SetPropertyValue "Receiver Status.Dim", "---"
	End Select
End Sub


'-------------------- Record Select --------------------
Sub Rx_RecordSelectState(State)

	Select Case State
		Case "!1SLR00", "!1SL300": SetPropertyValue "Receiver Status.Rec Select", "Video 1"
		Case "!1SLR01", "!1SL301": SetPropertyValue "Receiver Status.Rec Select", "Video 2"
		Case "!1SLR02", "!1SL302": SetPropertyValue "Receiver Status.Rec Select", "Video 3"
		Case "!1SLR03", "!1SL303": SetPropertyValue "Receiver Status.Rec Select", "Video 4"
		Case "!1SLR04", "!1SL304": SetPropertyValue "Receiver Status.Rec Select", "Video 5"
		Case "!1SLR05", "!1SL305": SetPropertyValue "Receiver Status.Rec Select", "Video 6"
		Case "!1SLR06", "!1SL306": SetPropertyValue "Receiver Status.Rec Select", "Video 7"
		Case "!1SLR10", "!1SL310": SetPropertyValue "Receiver Status.Rec Select", "DVD"
		Case "!1SLR20", "!1SL320": SetPropertyValue "Receiver Status.Rec Select", "Tape 1"
		Case "!1SLR21", "!1SL321": SetPropertyValue "Receiver Status.Rec Select", "Tape 2"
		Case "!1SLR22", "!1SL322": SetPropertyValue "Receiver Status.Rec Select", "Phono"
		Case "!1SLR23", "!1SL323": SetPropertyValue "Receiver Status.Rec Select", "CD"
		Case "!1SLR24", "!1SL324": SetPropertyValue "Receiver Status.Rec Select", "FM"
		Case "!1SLR25", "!1SL325": SetPropertyValue "Receiver Status.Rec Select", "AM"
		Case "!1SLR26", "!1SL326": SetPropertyValue "Receiver Status.Rec Select", "Tuner"
		Case "!1SLR27", "!1SL327": SetPropertyValue "Receiver Status.Rec Select", "Music Server"
		Case "!1SLR28", "!1SL328": SetPropertyValue "Receiver Status.Rec Select", "Internet Radio"
		Case "!1SLR30"           : SetPropertyValue "Receiver Status.Rec Select", "Multi Channel"
		Case "!1SLR7F", "!1SL37F": SetPropertyValue "Receiver Status.Rec Select", "Off"
		Case "!1SLR80", "!1SL380": SetPropertyValue "Receiver Status.Rec Select", "Source"
		Case Else		 : SetPropertyValue "Receiver Status.Rec Select", "---"
	End Select
End Sub


'------------------ Zone 2 Mute ------------------------
Sub Rx_Zone2MuteState(State)

	Select Case State
		Case "!1ZMT00":	SetPropertyValue "Receiver Status.Zone2 Mute", "Off"
		Case "!1ZMT01":	SetPropertyValue "Receiver Status.Zone2 Mute", "On"
		Case Else     :	SetPropertyValue "Receiver Status.Zone2 Mute", "---"
	End Select
End Sub


'-------------------- Zone2 Select ---------------------
Sub Rx_Zone2SelectState(State)

	Select Case State
		Case "!1SLZ00":	SetPropertyValue "Receiver Status.Zone2 Select", "Video 1"
		Case "!1SLZ01":	SetPropertyValue "Receiver Status.Zone2 Select", "Video 2"
		Case "!1SLZ02":	SetPropertyValue "Receiver Status.Zone2 Select", "Video 3"
		Case "!1SLZ03":	SetPropertyValue "Receiver Status.Zone2 Select", "Video 4"
		Case "!1SLZ04":	SetPropertyValue "Receiver Status.Zone2 Select", "Video 5"
		Case "!1SLZ05":	SetPropertyValue "Receiver Status.Zone2 Select", "Video 6"
		Case "!1SLZ06":	SetPropertyValue "Receiver Status.Zone2 Select", "Video 7"
		Case "!1SLZ10":	SetPropertyValue "Receiver Status.Zone2 Select", "DVD"
		Case "!1SLZ20":	SetPropertyValue "Receiver Status.Zone2 Select", "Tape 1"
		Case "!1SLZ21":	SetPropertyValue "Receiver Status.Zone2 Select", "Tape 2"
		Case "!1SLZ22":	SetPropertyValue "Receiver Status.Zone2 Select", "Phono"
		Case "!1SLZ23":	SetPropertyValue "Receiver Status.Zone2 Select", "CD"
		Case "!1SLZ24":	SetPropertyValue "Receiver Status.Zone2 Select", "FM"
		Case "!1SLZ25":	SetPropertyValue "Receiver Status.Zone2 Select", "AM"
		Case "!1SLZ26":	SetPropertyValue "Receiver Status.Zone2 Select", "Tuner"
		Case "!1SLZ27":	SetPropertyValue "Receiver Status.Zone2 Select", "Music Server"
		Case "!1SLZ28":	SetPropertyValue "Receiver Status.Zone2 Select", "Internet Radio"
		Case "!1SLZ30":	SetPropertyValue "Receiver Status.Zone2 Select", "Multi Channel"
		Case "!1SLZ7F":	SetPropertyValue "Receiver Status.Zone2 Select", "Off"
		Case "!1SLZ80":	SetPropertyValue "Receiver Status.Zone2 Select", "Source"
		Case Else     :	SetPropertyValue "Receiver Status.Zone2 Select", "---"
	End Select
	
	SetpropertyValue "Receiver Status.Action", "Power_Zone2 Status"
End Sub


'-------------------- Audio Selector -------------------
Sub Rx_AudioSelectorState(State)

	Select Case State
		Case "!1SLA00":	SetPropertyValue "Receiver Status.Audio Selector", "Auto"
		Case "!1SLA01":	SetPropertyValue "Receiver Status.Audio Selector", "Multi Channel"
		Case "!1SLA02":	SetPropertyValue "Receiver Status.Audio Selector", "Analoog"
		Case "!1SLA03":	SetPropertyValue "Receiver Status.Audio Selector", "iLink"
		Case Else     :	SetPropertyValue "Receiver Status.Audio Selector", "---"
	End Select
End Sub


'-------------------- Display Mode ---------------------
Sub Rx_DisplayModeCommandState(State)

	Select Case State
		Case "!1DIF00":	SetPropertyValue "Receiver Status.Display Mode", "0"
		Case "!1DIF01":	SetPropertyValue "Receiver Status.Display Mode", "1"
		Case Else     :	SetPropertyValue "Receiver Status.Display Mode", "---"
	End Select
End Sub


'-------------------- SetP -----------------------------
Sub Rx_ProcessSETPCommand(State)
Dim SETPData

	SETPData = Left(State,14)

	Select Case SETPData
		Case "!1SETP12VTrggA": Call Rx_TriggerState(State)
	End Select
End Sub


'-------------------- Volume ---------------------------
Sub Rx_VolumeState(State)
Dim VolumeData
Dim intVolume

	VolumeData = Right(State, 2)
	intVolume  = (CInt("&H" & Left(VolumeData, 1)) * 16) + CInt("&H" & Right(VolumeData, 1))
	SetPropertyValue "Receiver Status.Volume", intVolume
End Sub


'---------------- Zone 2 Volume ------------------------
Sub Rx_Zone2VolumeState(State)
Dim VolumeData
Dim intVolume

	VolumeData = Right(State, 2)
	intVolume  = (CInt("&H" & Left(VolumeData, 1)) * 16) + CInt("&H" & Right(VolumeData, 1))
	SetPropertyValue "Receiver Status.Zone2 Volume", intVolume
End Sub


'--------------------- SetTriggerState -----------------
Sub Rx_TriggerState(State)
Dim nit
Dim nic
Dim PropertyVal
Dim Trigger
Dim Delay
Dim Source
Dim TriggerState
Dim TriggerNumber(10)
Dim TriggerDelay(10)
Dim TriggerSource
Dim TriggerSourceNr

TriggerNumber(1) = "TriggerA"
TriggerNumber(2) = "TriggerB"
TriggerNumber(3) = "TriggerC"
TriggerNumber(4) = "TriggerD"
TriggerNumber(5) = "TriggerE"
TriggerDelay(1)  = "TriggerADelay"
TriggerDelay(2)  = "TriggerBDelay"
TriggerDelay(3)  = "TriggerCDelay"
TriggerDelay(4)  = "TriggerDDelay"
TriggerDelay(5)  = "TriggerEDelay"
TriggerSource    = Mid(State, 15, 1)
TriggerSourceNr  = Mid(State, 16, 1)

	Select Case TriggerSource
		Case "V": Source = "Video " + TriggerSourceNr
		Case "T": If TriggerSourceNr <> "U" Then
				Source = "Tape "  + TriggerSourceNr
			  Else
				Source = "Tuner"
			  End If
		Case "P": Source = "Phono"
		Case "C": Source = "CD"
		Case "D": Source = "DVD"
		Case "N": Source = "Net-Tune"
	End Select

	SetpropertyValue "Receiver Status.TriggerSource", Source

	nic = 1	
	For nit = 17 to 25 Step 2
		Trigger = Mid(State, nit, 1)
		Delay   = Mid(State, nit + 1, 1)
	
		Select Case Trigger
			Case "F": TriggerState = "Off"
			Case "M": TriggerState = "Main"
			Case "2": TriggerState = "Zone2"
			Case "3": TriggerState = "Zone3"
			Case "4": TriggerState = "Main/Z2"
			Case "5": TriggerState = "Main/Z3"
			Case "6": TriggerState = "Z2/Z3"
			Case "7": TriggerState = "Main/Z2/Z3"
		End Select
	
		PropertyVal = "Receiver Status." + TriggerNumber(nic)
		SetpropertyValue PropertyVal, TriggerState
		PropertyVal = "Receiver Status." + TriggerDelay(nic)
		SetPropertyValue PropertyVal, Delay
		nic = nic + 1
	Next
End Sub


'-------------------------------------------------------
'- Subs and Functions below are for Send Data ----------
'-------------------------------------------------------
'- Transmit Power (Main, Zone2, Zone3) -----------------
'-------------------------------------------------------
Sub Tx_Power(Data)
Dim PowerData
Dim PowerValue

	PowerData = Split(Data, " ")
	Select Case PowerData(0)
		Case "Main" : PowerValue = "!1PWR"
		Case "Zone2": PowerValue = "!1ZPW"
		Case "Zone3": PowerValue = "!1PW3"
		Case Else   : PowerValue = "!1PWR"
	End Select

	Select Case PowerData(1)
		Case "On"    : SetPropertyValue "Receiver.Send Data", PowerValue & "01"
		Case "Off"   : SetPropertyValue "Receiver.Send Data", PowerValue & "00"
		Case "Status": SetPropertyValue "Receiver.Send Data", PowerValue & "QSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Sleep --------------------------------------
'-------------------------------------------------------
Sub Tx_Sleep(Data)

	Select Case Data
		Case "Up"    : SetPropertyValue "Receiver.Send Data", "!1SLPUP"
		Case "Off"   : SetPropertyValue "Receiver.Send Data", "!1SLPOFF"
		Case "Status": SetPropertyValue "Receiver.Send Data", "!1SLPQSTN"
		Case Else    : SetPropertyValue "Receiver.Send Data", "!1SLP" & Data
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Mute (Main, Zone2) -------------------------
'-------------------------------------------------------
Sub Tx_Mute(Data)
Dim MuteData
Dim MuteValue

	MuteData = Split(Data, " ")
	Select Case MuteData(0)
		Case "Main" : MuteValue = "!1AMT"
		Case "Zone2": MuteValue = "!1ZMT"
		Case Else   : MuteValue = "!1AMT"
	End Select
	
	Select Case MuteData(1)
		Case "On"    : SetPropertyValue "Receiver.Send Data", MuteValue & "01"
		Case "Off"   : SetPropertyValue "Receiver.Send Data", MuteValue & "00"
		Case "Status": SetPropertyValue "Receiver.Send Data", MuteValue & "QSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Speaker (Speaker A, Speaker B) -------------
'-------------------------------------------------------
Sub Tx_Speaker(Data)
Dim SpeakerData
Dim SpeakerValue

	SpeakerData = Split(Data, " ")
	Select Case SpeakerData(0)
		Case "A" : SpeakerValue = "!1SPA"
		Case "B" : SpeakerValue = "!1SPB"
		Case Else: SpeakerValue = "!1SPA"
	End Select
	
	Select Case SpeakerData(1)
		Case "On"    : SetPropertyValue "Receiver.Send Data", SpeakerValue & "01"
		Case "Off"   : SetPropertyValue "Receiver.Send Data", SpeakerValue & "00"
		Case "Status": SetPropertyValue "Receiver.Send Data", SpeakerValue & "QSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Volume (Main, Zone2) -----------------------
'-------------------------------------------------------
Sub Tx_Volume(Data)
Dim VolumeData
Dim VolumeValue

	VolumeData = Split(Data, " ")
	Select Case VolumeData(0)
		Case "Main" : VolumeValue = "!1MVL"
		Case "Zone2": VolumeValue = "!1ZVL"
		Case Else   : VolumeValue = "!1MVL"
	End Select
	
	Select Case VolumeData(1)
		Case "Up"    : SetPropertyValue "Receiver.Send Data", VolumeValue & "UP"
		Case "Down"  : SetPropertyValue "Receiver.Send Data", VolumeValue & "DOWN"
		Case "Status": SetPropertyValue "Receiver.Send Data", VolumeValue & "QSTN"
		Case "Alarm" : SetPropertyValue "Receiver.Send Data", VolumeValue & "46"
		Case "Wekker": SetPropertyValue "Receiver.Send Data", VolumeValue & "23"
		Case "Phone" : SetPropertyValue "Receiver.Send Data", VolumeValue & "32"
		Case Else    : SetPropertyValue "Receiver.Send Data", VolumeValue & VolumeData(1)
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Selector (Main, Zone2, Zone3, Record) ------
'-------------------------------------------------------
Sub Tx_Selector(Data)
Dim SelectorData
Dim SelectorValue

	SelectorData = Split(Data, " ")
	Select Case SelectorData(0)
		Case "Main"  : SelectorValue = "!1SLI"
		Case "Zone2" : SelectorValue = "!1SLZ"
		Case "Zone3" : SelectorValue = "!1SL3"
		Case "Record": SelectorValue = "!1SLR"
		Case Else    : SelectorValue = "!1SLI"
	End Select

	Select Case SelectorData(1)
		Case "Video1"       : SetPropertyValue "Receiver.Send Data", SelectorValue & "00"
		Case "Video2"       : SetPropertyValue "Receiver.Send Data", SelectorValue & "01"
		Case "Video3"       : SetPropertyValue "Receiver.Send Data", SelectorValue & "02"
		Case "Video4"       : SetPropertyValue "Receiver.Send Data", SelectorValue & "03"
		Case "Video5"       : SetPropertyValue "Receiver.Send Data", SelectorValue & "04"
		Case "Video6"       : SetPropertyValue "Receiver.Send Data", SelectorValue & "05"
		Case "Video7"       : SetPropertyValue "Receiver.Send Data", SelectorValue & "06"
		Case "DVD" 	    : SetPropertyValue "Receiver.Send Data", SelectorValue & "10"
		Case "Tape1"        : SetPropertyValue "Receiver.Send Data", SelectorValue & "20"
		Case "Tape2"        : SetPropertyValue "Receiver.Send Data", SelectorValue & "21"
		Case "Phono"        : SetPropertyValue "Receiver.Send Data", SelectorValue & "22"
		Case "CD"           : SetPropertyValue "Receiver.Send Data", SelectorValue & "23"
		Case "FM"           : SetPropertyValue "Receiver.Send Data", SelectorValue & "24"
		Case "AM"           : SetPropertyValue "Receiver.Send Data", SelectorValue & "25"
		Case "Tuner"        : SetPropertyValue "Receiver.Send Data", SelectorValue & "26"
		Case "MusicServer"  : SetPropertyValue "Receiver.Send Data", SelectorValue & "27"
		Case "InternetRadio": SetPropertyValue "Receiver.Send Data", SelectorValue & "28"
		Case "MultiChannel" : SetPropertyValue "Receiver.Send Data", SelectorValue & "30"
		Case "Off"          : SetPropertyValue "Receiver.Send Data", SelectorValue & "7F"
	 	Case "Source" 	    : SetPropertyValue "Receiver.Send Data", SelectorValue & "80"
	End Select
	
	If SelectorData(1) = "Status" Or _
	  (SelectorData(0) = "Main"  And ReceiverMainPower  <> "On") Or _
	  (SelectorData(0) = "Zone2" And ReceiverZone2Power <> "On") Or _
	  (SelectorData(0) = "Zone3" And ReceiverZone3Power <> "On") Then
		SetPropertyValue "Receiver.Send Data", SelectorValue & "QSTN"
	End If
End Sub


'-------------------------------------------------------
'- Transmit Preset -------------------------------------
'-------------------------------------------------------
Sub Tx_Preset(Data)

	Select Case Data
		Case "Up"    : SetPropertyValue "Receiver.Send Data", "!1PRSUP"
		Case "Down"  : SetPropertyValue "Receiver.Send Data", "!1PRSDOWN"
		Case "Status": SetPropertyValue "Receiver.Send Data", "!1PRSQSTN"
		Case Else    : SetPropertyValue "Receiver.Send Data", "!1PRS" & Data
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Tuning -------------------------------------
'-------------------------------------------------------
Sub Tx_Tuning(Data)

	Select Case Data
		Case "Up"    : SetPropertyValue "Receiver.Send Data", "!1TUNUP"
		Case "Down"  : SetPropertyValue "Receiver.Send Data", "!1TUNDOWN"
		Case "Status": SetPropertyValue "Receiver.Send Data", "!1TUNQSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Listening Mode -----------------------------
'-------------------------------------------------------
Sub Tx_ListeningMode(Data)

	Select Case Data
		Case "Stereo"               : SetPropertyValue "Receiver.Send Data", "!1LMD00"
		Case "Direct"               : SetPropertyValue "Receiver.Send Data", "!1LMD01"
		Case "Surround"             : SetPropertyValue "Receiver.Send Data", "!1LMD02"
		Case "THX"                  : SetPropertyValue "Receiver.Send Data", "!1LMD04"
		Case "Action"               : SetPropertyValue "Receiver.Send Data", "!1LMD05"
		Case "Mono Movie"           : SetPropertyValue "Receiver.Send Data", "!1LMD07"
		Case "Orchestra"            : SetPropertyValue "Receiver.Send Data", "!1LMD08"
		Case "Unplugged"            : SetPropertyValue "Receiver.Send Data", "!1LMD09"
		Case "Studio-Mix"           : SetPropertyValue "Receiver.Send Data", "!1LMD0A"
		Case "TV Logic"             : SetPropertyValue "Receiver.Send Data", "!1LMD0B"
		Case "All Ch Stereo"        : SetPropertyValue "Receiver.Send Data", "!1LMD0C"
		Case "Theater Dimensional"  : SetPropertyValue "Receiver.Send Data", "!1LMD0D"
		Case "Enhanced 7"           : SetPropertyValue "Receiver.Send Data", "!1LMD0E"
		Case "Mono"                 : SetPropertyValue "Receiver.Send Data", "!1LMD0F"
		Case "Film"                 : SetPropertyValue "Receiver.Send Data", "!1LMD03"
		Case "Musical"              : SetPropertyValue "Receiver.Send Data", "!1LDM06"
		Case "Pure Audio"           : SetPropertyValue "Receiver.Send Data", "!1LMD11"
		Case "Full Mono"            : SetPropertyValue "Receiver.Send Data", "!1LMD13"
		Case "5.1ch Surround"       : SetPropertyValue "Receiver.Send Data", "!1LMD40"
		Case "Dolby EX"             : SetPropertyValue "Receiver.Send Data", "!1LMD41"
		Case "THX Cinema"           : SetPropertyValue "Receiver.Send Data", "!1LMD42"
		Case "THX Surround EX"      : SetPropertyValue "Receiver.Send Data", "!1LMD43"
		Case "PLII/PLIIx Movie"     : SetPropertyValue "Receiver.Send Data", "!1LMD80"
		Case "PLII/PLIIx Music"     : SetPropertyValue "Receiver.Send Data", "!1LMD81"
		Case "Neo:6 Cinema"         : SetPropertyValue "Receiver.Send Data", "!1LMD82"
		Case "Neo:6 Music"          : SetPropertyValue "Receiver.Send Data", "!1LMD83"
		Case "PLII/PLIIx THX Cinema": SetPropertyValue "Receiver.Send Data", "!1LMD84"
		Case "Neo:6 THX Cinema"     : SetPropertyValue "Receiver.Send Data", "!1LMD85"
		Case "PLII/PLIIx Game"      : SetPropertyValue "Receiver.Send Data", "!1LMD86"
		Case "Dolby VS"             : SetPropertyValue "Receiver.Send Data", "!1LMD14"
		Case "THX Games Mode"       : SetPropertyValue "Receiver.Send Data", "!1LMD52"
		Case "THX Ultra2 Cinema"    : SetPropertyValue "Receiver.Send Data", "!1LMD50"
		Case "THX Music Mode"       : SetPropertyValue "Receiver.Send Data", "!1LMD51"
		Case "MultiPlex"            : SetPropertyValue "Receiver.Send Data", "!1LMD12"
		Case "Rotate Up"            : SetPropertyValue "Receiver.Send Data", "!1LMDUP"
		Case "Rotate Down"          : SetPropertyValue "Receiver.Send Data", "!1LMDDOWN"
		Case "Status"               : SetPropertyValue "Receiver.Send Data", "!1LMDQSTN"

	End Select
End Sub


'-------------------------------------------------------
'- Transmit Late Night ---------------------------------
'-------------------------------------------------------
Sub Tx_LateNight(Data)

	Select Case Data
		Case "Off"   : SetPropertyValue "Receiver.Send Data", "!1LTN00"
		Case "Low"   : SetPropertyValue "Receiver.Send Data", "!1LTN01"
		Case "High"  : SetPropertyValue "Receiver.Send Data", "!1LTN02"
		Case "Rotate": SetPropertyValue "Receiver.Send Data", "!1LTNUP"
		Case "Status": SetPropertyValue "Receiver.Send Data", "!1LTNQSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Audio Selector -----------------------------
'-------------------------------------------------------
Sub Tx_AudioSelector(Data)

	Select Case Data
		Case "Auto"         : SetPropertyValue "Receiver.Send Data", "!1SLA00"
		Case "Multi Channel": SetPropertyValue "Receiver.Send Data", "!1SLA01"
		Case "Analog"       : SetPropertyValue "Receiver.Send Data", "!1SLA02"
		Case "iLink"        : SetPropertyValue "Receiver.Send Data", "!1SLA03"
		Case "Rotate"       : SetPropertyValue "Receiver.Send Data", "!1SLAUP"
		Case "Status"       : SetPropertyValue "Receiver.Send Data", "!1SLAQSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Re-EQ --------------------------------------
'-------------------------------------------------------
Sub Tx_ReEQ(Data)

	Select Case Data
		Case "Both Off"  : SetPropertyValue "Receiver.Send Data", "!1RAS00"
		Case "On"        : SetPropertyValue "Receiver.Send Data", "!1RAS01"
		Case "Academy On": SetPropertyValue "Receiver.Send Data", "!1RAS02"
		Case "Rotate"    : SetPropertyValue "Receiver.Send Data", "!1RASUP"
		Case "Status"    : SetPropertyValue "Receiver.Send Data", "!1RASQSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Digital Mode -------------------------------
'-------------------------------------------------------
Sub Tx_DigitalMode(Data)

	Select Case Data
		Case "Status": SetPropertyValue "Receiver.Send Data", "!1DMDQSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Dim ----------------------------------------
'-------------------------------------------------------
Sub Tx_Dim(Data)

	Select Case Data
		Case "Bright": SetPropertyValue "Receiver.Send Data", "!1DIM00"
		Case "Dim"   : SetPropertyValue "Receiver.Send Data", "!1DIM01"
		Case "Dark"  : SetPropertyValue "Receiver.Send Data", "!1DIM02"
		Case "Off"   : SetPropertyValue "Receiver.Send Data", "!1DIM03"
		Case "Rotary": SetPropertyValue "Receiver.Send Data", "!1DIMDIM"
		Case "Status": SetPropertyValue "Receiver.Send Data", "!1DIMQSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit On Screen Display --------------------------
'-------------------------------------------------------
Sub Tx_OSD(Data)

	Select Case Data
		Case "Menu" : SetPropertyValue "Receiver.Send Data", "!1OSDMENU"
		Case "Up"   : SetPropertyValue "Receiver.Send Data", "!1OSDUP"
		Case "Down" : SetPropertyValue "Receiver.Send Data", "!1OSDDOWN"
		Case "Right": SetPropertyValue "Receiver.Send Data", "!1OSDRIGHT"
		Case "Left" : SetPropertyValue "Receiver.Send Data", "!1OSDLEFT"
		Case "Enter": SetPropertyValue "Receiver.Send Data", "!1OSDENTER"
		Case "Exit" : SetPropertyValue "Receiver.Send Data", "!1OSDEXIT"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit On Screen Display --------------------------
'-------------------------------------------------------
Sub Tx_Display(Data)

	Select Case Data
		Case "Selector + Volume"        : SetPropertyValue "Receiver.Send Data", "!1DIF00"
		Case "Selector + Listening Mode": SetPropertyValue "Receiver.Send Data", "!1DIF01"
		Case "Rotary"                   : SetPropertyValue "Receiver.Send Data", "!1DIFTG"
		Case "Status"                   : SetPropertyValue "Receiver.Send Data", "!1DIFQSTN"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Triggers -----------------------------------
'-------------------------------------------------------
Sub Tx_Trigger(Data)

	Select Case Data
		Case "Video 1 On On"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV1M0F0F0F0F0"
		Case "Video 2 On On"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV2M0F0F0F0F0"
		Case "Video 3 On On"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV3M0F0F0F0F0"
		Case "Video 4 On On"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV5M0F0F0F0F0"
		Case "Video 5 On On"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV5M0F0F0F0F0"
		Case "Video 6 On On"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV6M0F0F0F0F0"
		Case "Video 7 On On"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV7M0F0F0F0F0"
		Case "Tape 1 On On"         : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAT1M0F0F0F0F0"
		Case "Tape 2 On On"         : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAT2M0F0F0F0F0"
		Case "Tuner On On"          : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAT2M0F0F0F0F0"
		Case "FM On On"             : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggATUM0F0F0F0F0"
		Case "AM On On"             : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggATUM0F0F0F0F0"
		Case "Music Server On On"   : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggANTM0F0F0F0F0"
		Case "Internet Radio On On" : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggANTM0F0F0F0F0"
		Case "CD On On"             : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggACDM0F0F0F0F0"
		Case "Phono On On"          : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAPHM0F0F0F0F0"
		Case "DVD On On"            : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggADVM0F0F0F0F0"
		Case "Video 1 On Off"       : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV1F0F0F0F0F0"
		Case "Video 2 On Off"       : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV2F0F0F0F0F0"
		Case "Video 3 On Off"       : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV3F0F0F0F0F0"
		Case "Video 4 On Off"       : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV4F0F0F0F0F0"
		Case "Video 5 On Off"       : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV5F0F0F0F0F0"
		Case "Video 6 On Off"       : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV6F0F0F0F0F0"
		Case "Video 7 On Off"       : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAV7F0F0F0F0F0"
		Case "Tape 1 On Off"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAT1F0F0F0F0F0"
		Case "Tape 2 On Off"        : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAT2F0F0F0F0F0"
		Case "Tuner On Off"         : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggATUF0F0F0F0F0"
		Case "FM On Off"            : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggATUF0F0F0F0F0"
		Case "AM On Off"            : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggATUF0F0F0F0F0"
		Case "Music Server On Off"  : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggANTF0F0F0F0F0"
		Case "Internet Radio On Off": SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggANTF0F0F0F0F0"
		Case "CD On Off"            : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggACDF0F0F0F0F0"
		Case "Phono On Off"         : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggAPHF0F0F0F0F0"
		Case "DVD On Off"           : SetPropertyValue "Receiver.Send Data", "!1SETP12VTrggADVF0F0F0F0F0"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit NetTune ------------------------------------
'-------------------------------------------------------
Sub Tx_NetTune(Data)

	Select Case Data
		Case "Play" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCPLAY"
		Case "Stop" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCSTOP"
		Case "Pause" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCPAUSE"
		Case "Track Up"  : SetPropertyValue "Receiver.Send Data", "!1NTCTRUP"
		Case "Track Down": SetPropertyValue "Receiver.Send Data", "!1NTCTRDN"
		Case "FF" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCFF"
		Case "Rew" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCREW"
		Case "Repeat" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCREPEAT"
		Case "Random" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCRANDOM"
		Case "Display" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCDISPLAY"
		Case "Album" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCALBUM"
		Case "Artist" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCARTIST"
		Case "Genre" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCGENRE"
		Case "Playlist"	 : SetPropertyValue "Receiver.Send Data", "!1NTCPLAYLIST"
		Case "Right" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCRIGHT"
		Case "Left" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCLEFT"
		Case "Up" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCUP"
		Case "Down" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCDOWN"
		Case "Select" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCSELECT"
		Case "0" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC0"
		Case "1" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC1"
		Case "2" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC2"
		Case "3" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC3"
		Case "4" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC4"
		Case "5" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC5"
		Case "6" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC6"
		Case "7" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC7"
		Case "8" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC8"
		Case "9" 	 : SetPropertyValue "Receiver.Send Data", "!1NTC9"
		Case "Delete" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCDELETE"
		Case "Caps" 	 : SetPropertyValue "Receiver.Send Data", "!1NTCCAPS"
		Case "Location"	 : SetPropertyValue "Receiver.Send Data", "!1NTCLOCATION"
		Case "Language"	 : SetPropertyValue "Receiver.Send Data", "!1NTCLANGUAGE"
	End Select
End Sub


'-------------------------------------------------------
'- Transmit Status Requests ----------------------------
'-------------------------------------------------------
Sub Tx_Status()

	Call Tx_Power("Main Status")
	Call Tx_Power("Zone2 Status")
	Call Tx_Power("Zone3 Status")
	Call Tx_Sleep("Status")
	Call Tx_Mute("Main Status")
	Call Tx_Mute("Zone2 Status")
	Call Tx_Speaker("A Status")
	Call Tx_Speaker("B Status")
	Call Tx_Volume("Main Status")
	Call Tx_Volume("Zone2 Status")
	Call Tx_Selector("Main Status")
	Call Tx_Selector("Zone2 Status")
	Call Tx_Selector("Zone3 Status")
	Call Tx_Selector("Record Status")
	Call Tx_Preset("Status")
	Call Tx_ListeningMode("Status")
	Call Tx_LateNight("Status")
	Call Tx_AudioSelector("Status")
	Call Tx_ReEQ("Status")
	Call Tx_DigitalMode("Status")
	Call Tx_Dim("Status")
	Call Tx_Display("Status")
	Call Tx_Tuning("Status")
End Sub


'-------------------------------------------------------
'- Integration: Wekker Radio Presets -------------------
'-------------------------------------------------------
Sub In_Wekker(Data)

	If Data = "Off" Then
		Call Tx_Power("Main Off")
		Call Tx_Power("Zone3 Off")
	Else
		Call Tx_Selector("Main FM")
		Call Tx_Volume("Main Wekker")
		Call Tx_Power("Zone3 On")
		Call Tx_Selector("Zone3 FM")
        	
		Select Case Data
			Case "Radio 3"  : Call Tx_Preset("03")
			Case "CAZ"      : Call Tx_Preset("04")
			Case "Sky Radio": Call Tx_Preset("05")
			Case "Radio 538": Call Tx_Preset("06")
		End Select
	End If
End Sub
